/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.35.0-dev.20230121(212670ceb460441b3ebed29e6ca30aa1e9bdde85)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],Q=function(U){for(var n=[],A=0,M=U.length;A<M;A++)n[A]=X[U[A]];return n},Ee=this,Re=typeof global=="object"?global:{},ae;(function(U){U.global=Ee;var n=function(){function A(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(A.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),A.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=A._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof U.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},A._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},A}();U.Environment=n})(ae||(ae={}));var ae;(function(U){var n=function(){function i(c,p,C){this.type=c,this.detail=p,this.timestamp=C}return i}();U.LoaderEvent=n;var A=function(){function i(c){this._events=[new n(1,"",c)]}return i.prototype.record=function(c,p){this._events.push(new n(c,p,U.Utilities.getHighPerformanceTimestamp()))},i.prototype.getEvents=function(){return this._events},i}();U.LoaderEventRecorder=A;var M=function(){function i(){}return i.prototype.record=function(c,p){},i.prototype.getEvents=function(){return[]},i.INSTANCE=new i,i}();U.NullLoaderEventRecorder=M})(ae||(ae={}));var ae;(function(U){var n=function(){function A(){}return A.fileUriToFilePath=function(M,i){if(i=decodeURI(i).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i},A.startsWith=function(M,i){return M.length>=i.length&&M.substr(0,i.length)===i},A.endsWith=function(M,i){return M.length>=i.length&&M.substr(M.length-i.length)===i},A.containsQueryString=function(M){return/^[^\#]*\?/gi.test(M)},A.isAbsolutePath=function(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)},A.forEachProperty=function(M,i){if(M){var c=void 0;for(c in M)M.hasOwnProperty(c)&&i(c,M[c])}},A.isEmpty=function(M){var i=!0;return A.forEachProperty(M,function(){i=!1}),i},A.recursiveClone=function(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;var i=Array.isArray(M)?[]:{};return A.forEachProperty(M,function(c,p){p&&typeof p=="object"?i[c]=A.recursiveClone(p):i[c]=p}),i},A.generateAnonymousModule=function(){return"===anonymous"+A.NEXT_ANONYMOUS_ID+++"==="},A.isAnonymousModule=function(M){return A.startsWith(M,"===anonymous")},A.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=U.global.performance&&typeof U.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?U.global.performance.now():Date.now()},A.NEXT_ANONYMOUS_ID=1,A.PERFORMANCE_NOW_PROBED=!1,A.HAS_PERFORMANCE_NOW=!1,A}();U.Utilities=n})(ae||(ae={}));var ae;(function(U){function n(i){if(i instanceof Error)return i;var c=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(c.stack=i.stack),c}U.ensureError=n;var A=function(){function i(){}return i.validateConfigurationOptions=function(c){function p(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=p),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(U.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){var C=n(new Error("INVALID cached data configuration, 'path' MUST be set"));C.phase="configuration",c.onError(C),c.nodeCachedData=void 0}return c},i.mergeConfigurationOptions=function(c,p){c===void 0&&(c=null),p===void 0&&(p=null);var C=U.Utilities.recursiveClone(p||{});return U.Utilities.forEachProperty(c,function(o,f){o==="ignoreDuplicateModules"&&typeof C.ignoreDuplicateModules<"u"?C.ignoreDuplicateModules=C.ignoreDuplicateModules.concat(f):o==="paths"&&typeof C.paths<"u"?U.Utilities.forEachProperty(f,function(S,e){return C.paths[S]=e}):o==="config"&&typeof C.config<"u"?U.Utilities.forEachProperty(f,function(S,e){return C.config[S]=e}):C[o]=U.Utilities.recursiveClone(f)}),i.validateConfigurationOptions(C)},i}();U.ConfigurationOptionsUtil=A;var M=function(){function i(c,p){if(this._env=c,this.options=A.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var C=this.options.nodeRequire.main.filename,o=Math.max(C.lastIndexOf("/"),C.lastIndexOf("\\"));this.options.baseUrl=C.substring(0,o+1)}}return i.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0},i.prototype._createSortedPathsRules=function(){var c=this;this.sortedPathsRules=[],U.Utilities.forEachProperty(this.options.paths,function(p,C){Array.isArray(C)?c.sortedPathsRules.push({from:p,to:C}):c.sortedPathsRules.push({from:p,to:[C]})}),this.sortedPathsRules.sort(function(p,C){return C.from.length-p.from.length})},i.prototype.cloneAndMerge=function(c){return new i(this._env,A.mergeConfigurationOptions(c,this.options))},i.prototype.getOptionsLiteral=function(){return this.options},i.prototype._applyPaths=function(c){for(var p,C=0,o=this.sortedPathsRules.length;C<o;C++)if(p=this.sortedPathsRules[C],U.Utilities.startsWith(c,p.from)){for(var f=[],S=0,e=p.to.length;S<e;S++)f.push(p.to[S]+c.substr(p.from.length));return f}return[c]},i.prototype._addUrlArgsToUrl=function(c){return U.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs},i.prototype._addUrlArgsIfNecessaryToUrl=function(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c},i.prototype._addUrlArgsIfNecessaryToUrls=function(c){if(this.options.urlArgs)for(var p=0,C=c.length;p<C;p++)c[p]=this._addUrlArgsToUrl(c[p]);return c},i.prototype.moduleIdToPaths=function(c){if(this._env.isNode){var p=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c);if(p)return this.isBuild()?["empty:"]:["node|"+c]}var C=c,o;if(!U.Utilities.endsWith(C,".js")&&!U.Utilities.isAbsolutePath(C)){o=this._applyPaths(C);for(var f=0,S=o.length;f<S;f++)this.isBuild()&&o[f]==="empty:"||(U.Utilities.isAbsolutePath(o[f])||(o[f]=this.options.baseUrl+o[f]),!U.Utilities.endsWith(o[f],".js")&&!U.Utilities.containsQueryString(o[f])&&(o[f]=o[f]+".js"))}else!U.Utilities.endsWith(C,".js")&&!U.Utilities.containsQueryString(C)&&(C=C+".js"),o=[C];return this._addUrlArgsIfNecessaryToUrls(o)},i.prototype.requireToUrl=function(c){var p=c;return U.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],U.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)},i.prototype.isBuild=function(){return this.options.isBuild},i.prototype.shouldInvokeFactory=function(c){return!!(!this.options.isBuild||U.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])},i.prototype.isDuplicateMessageIgnoredFor=function(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)},i.prototype.getConfigForModule=function(c){if(this.options.config)return this.options.config[c]},i.prototype.shouldCatchError=function(){return this.options.catchError},i.prototype.shouldRecordStats=function(){return this.options.recordStats},i.prototype.onError=function(c){this.options.onError(c)},i}();U.Configuration=M})(ae||(ae={}));var ae;(function(U){var n=function(){function o(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(f,S,e,v){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){var m=f.getConfig().getOptionsLiteral().preferScriptTags;m?this._scriptLoader=new A:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new A;var w={callback:e,errorback:v};if(this._callbackMap.hasOwnProperty(S)){this._callbackMap[S].push(w);return}this._callbackMap[S]=[w],this._scriptLoader.load(f,S,function(){return h.triggerCallback(S)},function(y){return h.triggerErrorback(S,y)})},o.prototype.triggerCallback=function(f){var S=this._callbackMap[f];delete this._callbackMap[f];for(var e=0;e<S.length;e++)S[e].callback()},o.prototype.triggerErrorback=function(f,S){var e=this._callbackMap[f];delete this._callbackMap[f];for(var v=0;v<e.length;v++)e[v].errorback(S)},o}(),A=function(){function o(){}return o.prototype.attachListeners=function(f,S,e){var v=function(){f.removeEventListener("load",h),f.removeEventListener("error",m)},h=function(w){v(),S()},m=function(w){v(),e(w)};f.addEventListener("load",h),f.addEventListener("error",m)},o.prototype.load=function(f,S,e,v){if(/^node\|/.test(S)){var h=f.getConfig().getOptionsLiteral(),m=p(f.getRecorder(),h.nodeRequire||U.global.nodeRequire),w=S.split("|"),y=null;try{y=m(w[1])}catch(l){v(l);return}f.enqueueDefineAnonymousModule([],function(){return y}),e()}else{var _=document.createElement("script");_.setAttribute("async","async"),_.setAttribute("type","text/javascript"),this.attachListeners(_,e,v);var g=f.getConfig().getOptionsLiteral().trustedTypesPolicy;g&&(S=g.createScriptURL(S)),_.setAttribute("src",S);var L=f.getConfig().getOptionsLiteral().cspNonce;L&&_.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(_)}},o}();function M(o){var f=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var S=f?self.eval(f.createScript("","true")):new Function("true");return S.call(self),!0}catch{return!1}}var i=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(f)),this._cachedCanUseEval},o.prototype.load=function(f,S,e,v){if(/^node\|/.test(S)){var h=f.getConfig().getOptionsLiteral(),m=p(f.getRecorder(),h.nodeRequire||U.global.nodeRequire),w=S.split("|"),y=null;try{y=m(w[1])}catch(L){v(L);return}f.enqueueDefineAnonymousModule([],function(){return y}),e()}else{var _=f.getConfig().getOptionsLiteral().trustedTypesPolicy,g=/^((http:)|(https:)|(file:))/.test(S)&&S.substring(0,self.origin.length)!==self.origin;if(!g&&this._canUseEval(f)){fetch(S).then(function(L){if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(function(L){L=L+`
//# sourceURL=`+S;var l=_?self.eval(_.createScript("",L)):new Function(L);l.call(self),e()}).then(void 0,v);return}try{_&&(S=_.createScriptURL(S)),importScripts(S),e()}catch(L){v(L)}}},o}(),c=function(){function o(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},o.prototype._initNodeRequire=function(f,S){var e=S.getConfig().getOptionsLiteral().nodeCachedData;if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var v=this,h=f("module");function m(w){var y=w.constructor,_=function(L){try{return w.require(L)}finally{}};return _.resolve=function(L,l){return y._resolveFilename(L,w,!1,l)},_.resolve.paths=function(L){return y._resolveLookupPaths(L,w)},_.main=process.mainModule,_.extensions=y._extensions,_.cache=y._cache,_}h.prototype._compile=function(w,y){var _=h.wrap(w.replace(/^#!.*/,"")),g=S.getRecorder(),L=v._getCachedDataPath(e,y),l={filename:y},d;try{var s=v._fs.readFileSync(L);d=s.slice(0,16),l.cachedData=s.slice(16),g.record(60,L)}catch{g.record(61,L)}var a=new v._vm.Script(_,l),r=a.runInThisContext(l),u=v._path.dirname(y),b=m(this),N=[this.exports,b,this,y,u,process,Re,Buffer],R=r.apply(this.exports,N);return v._handleCachedData(a,_,L,!l.cachedData,S),v._verifyCachedData(a,_,L,d,S),R}},o.prototype.load=function(f,S,e,v){var h=this,m=f.getConfig().getOptionsLiteral(),w=p(f.getRecorder(),m.nodeRequire||U.global.nodeRequire),y=m.nodeInstrumenter||function(r){return r};this._init(w),this._initNodeRequire(w,f);var _=f.getRecorder();if(/^node\|/.test(S)){var g=S.split("|"),L=null;try{L=w(g[1])}catch(r){v(r);return}f.enqueueDefineAnonymousModule([],function(){return L}),e()}else{S=U.Utilities.fileUriToFilePath(this._env.isWindows,S);var l=this._path.normalize(S),d=this._getElectronRendererScriptPathOrUri(l),s=Boolean(m.nodeCachedData),a=s?this._getCachedDataPath(m.nodeCachedData,S):void 0;this._readSourceAndCachedData(l,a,_,function(r,u,b,N){if(r){v(r);return}var R;u.charCodeAt(0)===o._BOM?R=o._PREFIX+u.substring(1)+o._SUFFIX:R=o._PREFIX+u+o._SUFFIX,R=y(R,l);var E={filename:d,cachedData:b},P=h._createAndEvalScript(f,R,E,e,v);h._handleCachedData(P,R,a,s&&!b,f),h._verifyCachedData(P,R,a,N,f)})}},o.prototype._createAndEvalScript=function(f,S,e,v,h){var m=f.getRecorder();m.record(31,e.filename);var w=new this._vm.Script(S,e),y=w.runInThisContext(e),_=f.getGlobalAMDDefineFunc(),g=!1,L=function(){return g=!0,_.apply(null,arguments)};return L.amd=_.amd,y.call(U.global,f.getGlobalAMDRequireFunc(),L,e.filename,this._path.dirname(e.filename)),m.record(32,e.filename),g?v():h(new Error("Didn't receive define call in "+e.filename+"!")),w},o.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var S=f.match(/^([a-z])\:(.*)/i);return S?"file:///"+(S[1].toUpperCase()+":"+S[2]).replace(/\\/g,"/"):"file://"+f},o.prototype._getCachedDataPath=function(f,S){var e=this._crypto.createHash("md5").update(S,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),v=this._path.basename(S).replace(/\.js$/,"");return this._path.join(f.path,v+"-"+e+".code")},o.prototype._handleCachedData=function(f,S,e,v,h){var m=this;f.cachedDataRejected?this._fs.unlink(e,function(w){h.getRecorder().record(62,e),m._createAndWriteCachedData(f,S,e,h),w&&h.getConfig().onError(w)}):v&&this._createAndWriteCachedData(f,S,e,h)},o.prototype._createAndWriteCachedData=function(f,S,e,v){var h=this,m=Math.ceil(v.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),w=-1,y=0,_=void 0,g=function(){setTimeout(function(){_||(_=h._crypto.createHash("md5").update(S,"utf8").digest());var L=f.createCachedData();if(!(L.length===0||L.length===w||y>=5)){if(L.length<w){g();return}w=L.length,h._fs.writeFile(e,Buffer.concat([_,L]),function(l){l&&v.getConfig().onError(l),v.getRecorder().record(63,e),g()})}},m*Math.pow(4,y++))};g()},o.prototype._readSourceAndCachedData=function(f,S,e,v){if(!S)this._fs.readFile(f,{encoding:"utf8"},v);else{var h=void 0,m=void 0,w=void 0,y=2,_=function(g){g?v(g):--y===0&&v(void 0,h,m,w)};this._fs.readFile(f,{encoding:"utf8"},function(g,L){h=L,_(g)}),this._fs.readFile(S,function(g,L){!g&&L&&L.length>0?(w=L.slice(0,16),m=L.slice(16),e.record(60,S)):e.record(61,S),_()})}},o.prototype._verifyCachedData=function(f,S,e,v,h){var m=this;!v||f.cachedDataRejected||setTimeout(function(){var w=m._crypto.createHash("md5").update(S,"utf8").digest();v.equals(w)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+e+"' now, but a RESTART IS REQUIRED")),m._fs.unlink(e,function(y){y&&h.getConfig().onError(y)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function p(o,f){if(f.__$__isRecorded)return f;var S=function(v){o.record(33,v);try{return f(v)}finally{o.record(34,v)}};return S.__$__isRecorded=!0,S}U.ensureRecordedNodeRequire=p;function C(o){return new n(o)}U.createScriptLoader=C})(ae||(ae={}));var ae;(function(U){var n=function(){function C(o){var f=o.lastIndexOf("/");f!==-1?this.fromModulePath=o.substr(0,f+1):this.fromModulePath=""}return C._normalizeModuleId=function(o){var f=o,S;for(S=/\/\.\//;S.test(f);)f=f.replace(S,"/");for(f=f.replace(/^\.\//g,""),S=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;S.test(f);)f=f.replace(S,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},C.prototype.resolveModule=function(o){var f=o;return U.Utilities.isAbsolutePath(f)||(U.Utilities.startsWith(f,"./")||U.Utilities.startsWith(f,"../"))&&(f=C._normalizeModuleId(this.fromModulePath+f)),f},C.ROOT=new C(""),C}();U.ModuleIdResolver=n;var A=function(){function C(o,f,S,e,v,h){this.id=o,this.strId=f,this.dependencies=S,this._callback=e,this._errorback=v,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return C._safeInvokeFunction=function(o,f){try{return{returnedValue:o.apply(U.global,f),producedError:null}}catch(S){return{returnedValue:null,producedError:S}}},C._invokeFactory=function(o,f,S,e){return o.shouldInvokeFactory(f)?o.shouldCatchError()?this._safeInvokeFunction(S,e):{returnedValue:S.apply(U.global,e),producedError:null}:{returnedValue:null,producedError:null}},C.prototype.complete=function(o,f,S,e){this._isComplete=!0;var v=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var h=C._invokeFactory(f,this.strId,this._callback,S);v=h.producedError,o.record(22,this.strId),!v&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||U.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(v){var m=U.ensureError(v);m.phase="factory",m.moduleId=this.strId,m.neededBy=e(this.id),this.error=m,f.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},C.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},C.prototype.isComplete=function(){return this._isComplete},C}();U.Module=A;var M=function(){function C(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return C.prototype.getMaxModuleId=function(){return this._nextId},C.prototype.getModuleId=function(o){var f=this._strModuleIdToIntModuleId.get(o);return typeof f>"u"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(o,f),this._intModuleIdToStrModuleId[f]=o),f},C.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},C}(),i=function(){function C(o){this.id=o}return C.EXPORTS=new C(0),C.MODULE=new C(1),C.REQUIRE=new C(2),C}();U.RegularDependency=i;var c=function(){function C(o,f,S){this.id=o,this.pluginId=f,this.pluginParam=S}return C}();U.PluginDependency=c;var p=function(){function C(o,f,S,e,v){v===void 0&&(v=0),this._env=o,this._scriptLoader=f,this._loaderAvailableTimestamp=v,this._defineFunc=S,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new U.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return C.prototype.reset=function(){return new C(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},C.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},C.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},C._findRelevantLocationInStack=function(o,f){for(var S=function(l){return l.replace(/\\/g,"/")},e=S(o),v=f.split(/\n/),h=0;h<v.length;h++){var m=v[h].match(/(.*):(\d+):(\d+)\)?$/);if(m){var w=m[1],y=m[2],_=m[3],g=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(g),w=S(w),w===e){var L={line:parseInt(y,10),col:parseInt(_,10)};return L.line===1&&(L.col-=53),L}}}throw new Error("Could not correlate define call site for needle "+o)},C.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],f=0,S=0,e=this._modules2.length;S<e;S++){var v=this._modules2[S];if(!!v){var h=this._buildInfoPath[v.id]||null,m=this._buildInfoDefineStack[v.id]||null,w=this._buildInfoDependencies[v.id];o[f++]={id:v.strId,path:h,defineLocation:h&&m?C._findRelevantLocationInStack(h,m):null,dependencies:w,shim:null,exports:v.exports}}}return o},C.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new U.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=U.NullLoaderEventRecorder.INSTANCE),this._recorder},C.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},C.prototype.enqueueDefineAnonymousModule=function(o,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var S=null;this._config.isBuild()&&(S=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:S,dependencies:o,callback:f}},C.prototype.defineModule=function(o,f,S,e,v,h){var m=this;h===void 0&&(h=new n(o));var w=this._moduleIdProvider.getModuleId(o);if(this._modules2[w]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var y=new A(w,o,this._normalizeDependencies(f,h),S,e,h);this._modules2[w]=y,this._config.isBuild()&&(this._buildInfoDefineStack[w]=v,this._buildInfoDependencies[w]=(y.dependencies||[]).map(function(_){return m._moduleIdProvider.getStrModuleId(_.id)})),this._resolve(y)},C.prototype._normalizeDependency=function(o,f){if(o==="exports")return i.EXPORTS;if(o==="module")return i.MODULE;if(o==="require")return i.REQUIRE;var S=o.indexOf("!");if(S>=0){var e=f.resolveModule(o.substr(0,S)),v=f.resolveModule(o.substr(S+1)),h=this._moduleIdProvider.getModuleId(e+"!"+v),m=this._moduleIdProvider.getModuleId(e);return new c(h,m,v)}return new i(this._moduleIdProvider.getModuleId(f.resolveModule(o)))},C.prototype._normalizeDependencies=function(o,f){for(var S=[],e=0,v=0,h=o.length;v<h;v++)S[e++]=this._normalizeDependency(o[v],f);return S},C.prototype._relativeRequire=function(o,f,S,e){if(typeof f=="string")return this.synchronousRequire(f,o);this.defineModule(U.Utilities.generateAnonymousModule(),f,S,e,null,o)},C.prototype.synchronousRequire=function(o,f){f===void 0&&(f=new n(o));var S=this._normalizeDependency(o,f),e=this._modules2[S.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports},C.prototype.configure=function(o,f){var S=this._config.shouldRecordStats();f?this._config=new U.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!S&&(this._recorder=null)},C.prototype.getConfig=function(){return this._config},C.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),f.dependencies,f.callback,null,f.stack)}},C.prototype._createLoadError=function(o,f){var S=this,e=this._moduleIdProvider.getStrModuleId(o),v=(this._inverseDependencies2[o]||[]).map(function(m){return S._moduleIdProvider.getStrModuleId(m)}),h=U.ensureError(f);return h.phase="loading",h.moduleId=e,h.neededBy=v,h},C.prototype._onLoadError=function(o,f){var S=this._createLoadError(o,f);this._modules2[o]||(this._modules2[o]=new A(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var e=[],v=0,h=this._moduleIdProvider.getMaxModuleId();v<h;v++)e[v]=!1;var m=!1,w=[];for(w.push(o),e[o]=!0;w.length>0;){var y=w.shift(),_=this._modules2[y];_&&(m=_.onDependencyError(S)||m);var g=this._inverseDependencies2[y];if(g)for(var v=0,h=g.length;v<h;v++){var L=g[v];e[L]||(w.push(L),e[L]=!0)}}m||this._config.onError(S)},C.prototype._hasDependencyPath=function(o,f){var S=this._modules2[o];if(!S)return!1;for(var e=[],v=0,h=this._moduleIdProvider.getMaxModuleId();v<h;v++)e[v]=!1;var m=[];for(m.push(S),e[o]=!0;m.length>0;){var w=m.shift(),y=w.dependencies;if(y)for(var v=0,h=y.length;v<h;v++){var _=y[v];if(_.id===f)return!0;var g=this._modules2[_.id];g&&!e[_.id]&&(e[_.id]=!0,m.push(g))}}return!1},C.prototype._findCyclePath=function(o,f,S){if(o===f||S===50)return[o];var e=this._modules2[o];if(!e)return null;var v=e.dependencies;if(v)for(var h=0,m=v.length;h<m;h++){var w=this._findCyclePath(v[h].id,f,S+1);if(w!==null)return w.push(o),w}return null},C.prototype._createRequire=function(o){var f=this,S=function(e,v,h){return f._relativeRequire(o,e,v,h)};return S.toUrl=function(e){return f._config.requireToUrl(o.resolveModule(e))},S.getStats=function(){return f.getLoaderEvents()},S.hasDependencyCycle=function(){return f._hasDependencyCycle},S.config=function(e,v){v===void 0&&(v=!1),f.configure(e,v)},S.__$__nodeRequire=U.global.nodeRequire,S},C.prototype._loadModule=function(o){var f=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var S=this._moduleIdProvider.getStrModuleId(o),e=this._config.moduleIdToPaths(S),v=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(S.indexOf("/")===-1||v.test(S))&&e.push("node|"+S);var h=-1,m=function(w){if(h++,h>=e.length)f._onLoadError(o,w);else{var y=e[h],_=f.getRecorder();if(f._config.isBuild()&&y==="empty:"){f._buildInfoPath[o]=y,f.defineModule(f._moduleIdProvider.getStrModuleId(o),[],null,null,null),f._onLoad(o);return}_.record(10,y),f._scriptLoader.load(f,y,function(){f._config.isBuild()&&(f._buildInfoPath[o]=y),_.record(11,y),f._onLoad(o)},function(g){_.record(12,y),m(g)})}};m(null)}},C.prototype._loadPluginDependency=function(o,f){var S=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var e=function(v){S.defineModule(S._moduleIdProvider.getStrModuleId(f.id),[],v,null,null)};e.error=function(v){S._config.onError(S._createLoadError(f.id,v))},o.load(f.pluginParam,this._createRequire(n.ROOT),e,this._config.getOptionsLiteral())}},C.prototype._resolve=function(o){var f=this,S=o.dependencies;if(S)for(var e=0,v=S.length;e<v;e++){var h=S[e];if(h===i.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(h===i.MODULE){o.unresolvedDependenciesCount--;continue}if(h===i.REQUIRE){o.unresolvedDependenciesCount--;continue}var m=this._modules2[h.id];if(m&&m.isComplete()){if(m.error){o.onDependencyError(m.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var w=this._findCyclePath(h.id,o.id,0)||[];w.reverse(),w.push(h.id),console.warn(w.map(function(g){return f._moduleIdProvider.getStrModuleId(g)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(o.id),h instanceof c){var y=this._modules2[h.pluginId];if(y&&y.isComplete()){this._loadPluginDependency(y.exports,h);continue}var _=this._inversePluginDependencies2.get(h.pluginId);_||(_=[],this._inversePluginDependencies2.set(h.pluginId,_)),_.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},C.prototype._onModuleComplete=function(o){var f=this,S=this.getRecorder();if(!o.isComplete()){var e=o.dependencies,v=[];if(e)for(var h=0,m=e.length;h<m;h++){var w=e[h];if(w===i.EXPORTS){v[h]=o.exports;continue}if(w===i.MODULE){v[h]={id:o.strId,config:function(){return f._config.getConfigForModule(o.strId)}};continue}if(w===i.REQUIRE){v[h]=this._createRequire(o.moduleIdResolver);continue}var y=this._modules2[w.id];if(y){v[h]=y.exports;continue}v[h]=null}var _=function(s){return(f._inverseDependencies2[s]||[]).map(function(a){return f._moduleIdProvider.getStrModuleId(a)})};o.complete(S,this._config,v,_);var g=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,g)for(var h=0,m=g.length;h<m;h++){var L=g[h],l=this._modules2[L];l.unresolvedDependenciesCount--,l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}var d=this._inversePluginDependencies2.get(o.id);if(d){this._inversePluginDependencies2.delete(o.id);for(var h=0,m=d.length;h<m;h++)this._loadPluginDependency(o.exports,d[h])}}},C}();U.ModuleManager=p})(ae||(ae={}));var Y,ae;(function(U){var n=new U.Environment,A=null,M=function(C,o,f){typeof C!="string"&&(f=o,o=C,C=null),(typeof o!="object"||!Array.isArray(o))&&(f=o,o=null),o||(o=["require","exports","module"]),C?A.defineModule(C,o,f,null,null):A.enqueueDefineAnonymousModule(o,f)};M.amd={jQuery:!0};var i=function(C,o){o===void 0&&(o=!1),A.configure(C,o)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return A.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){A.defineModule(U.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=i,c.getConfig=function(){return A.getConfig().getOptionsLiteral()},c.reset=function(){A=A.reset()},c.getBuildInfo=function(){return A.getBuildInfo()},c.getStats=function(){return A.getLoaderEvents()},c.define=M;function p(){if(typeof U.global.require<"u"||typeof require<"u"){var C=U.global.require||require;if(typeof C=="function"&&typeof C.resolve=="function"){var o=U.ensureRecordedNodeRequire(A.getRecorder(),C);U.global.nodeRequire=o,c.nodeRequire=o,c.__$__nodeRequire=o}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=c:(n.isElectronRenderer||(U.global.define=M),U.global.require=c)}U.init=p,(typeof U.global.define!="function"||!U.global.define.amd)&&(A=new U.ModuleManager(n,U.createScriptLoader(n),M,c,U.Utilities.getHighPerformanceTimestamp()),typeof U.global.require<"u"&&typeof U.global.require!="function"&&c.config(U.global.require),Y=function(){return M.apply(null,arguments)},Y.amd=M.amd,typeof doNotInitLoader>"u"&&p())})(ae||(ae={}));var le=this&&this.__awaiter||function(U,n,A,M){function i(c){return c instanceof A?c:new A(function(p){p(c)})}return new(A||(A=Promise))(function(c,p){function C(S){try{f(M.next(S))}catch(e){p(e)}}function o(S){try{f(M.throw(S))}catch(e){p(e)}}function f(S){S.done?c(S.value):i(S.value).then(C,o)}f((M=M.apply(U,n||[])).next())})};Y(X[22],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let A=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function i(m,w){let y;return w.length===0?y=m:y=m.replace(/\{(\d+)\}/g,(_,g)=>{const L=g[0],l=w[L];let d=_;return typeof l=="string"?d=l:(typeof l=="number"||typeof l=="boolean"||l===void 0||l===null)&&(d=String(l)),d}),A&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function c(m,w){let y=m[w];return y||(y=m["*"],y)?y:null}function p(m){return m.charAt(m.length-1)==="/"?m:m+"/"}function C(m,w,y){return le(this,void 0,void 0,function*(){const _=p(m)+p(w)+"vscode/"+p(y),g=yield fetch(_);if(g.ok)return yield g.json();throw new Error(`${g.status} - ${g.statusText}`)})}function o(m){return function(w,y){const _=Array.prototype.slice.call(arguments,2);return i(m[w],_)}}function f(m,w,...y){return i(w,y)}n.localize=f;function S(m){}n.getConfiguredDefaultLocale=S;function e(m){A=m}n.setPseudoTranslation=e;function v(m,w){var y;return{localize:o(w[m]),getConfiguredDefaultLocale:(y=w.getConfiguredDefaultLocale)!==null&&y!==void 0?y:_=>{}}}n.create=v;function h(m,w,y,_){var g;const L=(g=_["vs/nls"])!==null&&g!==void 0?g:{};if(!m||m.length===0)return y({localize:f,getConfiguredDefaultLocale:()=>{var r;return(r=L.availableLanguages)===null||r===void 0?void 0:r["*"]}});const l=L.availableLanguages?c(L.availableLanguages,m):null,d=l===null||l===M;let s=".nls";d||(s=s+"."+l);const a=r=>{Array.isArray(r)?r.localize=o(r):r.localize=o(r[m]),r.getConfiguredDefaultLocale=()=>{var u;return(u=L.availableLanguages)===null||u===void 0?void 0:u["*"]},y(r)};typeof L.loadBundle=="function"?L.loadBundle(m,l,(r,u)=>{r?w([m+".nls"],a):a(u)}):L.translationServiceUrl&&!d?le(this,void 0,void 0,function*(){var r;try{const u=yield C(L.translationServiceUrl,l,m);return a(u)}catch(u){if(!l.includes("-"))return console.error(u),w([m+".nls"],a);try{const b=l.split("-")[0],N=yield C(L.translationServiceUrl,b,m);return(r=L.availableLanguages)!==null&&r!==void 0||(L.availableLanguages={}),L.availableLanguages["*"]=b,a(N)}catch(b){return console.error(b),w([m+".nls"],a)}}}):w([m+s],a,r=>{if(s===".nls"){console.error("Failed trying to load default language strings",r);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,r),w([m+".nls"],a)})}n.load=h}),function(){var U,n;const A=self.MonacoEnvironment,M=A&&A.baseUrl?A.baseUrl:"../../../",i=typeof((U=self.trustedTypes)===null||U===void 0?void 0:U.createPolicy)=="function"?(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("amdLoader",{createScriptURL:e=>e,createScript:(e,...v)=>{const h=v.slice(0,-1).join(","),m=v.pop().toString();return`(function anonymous(${h}) { ${m}
})`}}):void 0;function c(){try{return(i?self.eval(i.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function p(){return new Promise((e,v)=>{if(typeof self.define=="function"&&self.define.amd)return e();const h=M+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&c()){fetch(h).then(w=>{if(w.status!==200)throw new Error(w.statusText);return w.text()}).then(w=>{w=`${w}
//# sourceURL=${h}`,(i?self.eval(i.createScript("",w)):new Function(w)).call(self),e()}).then(void 0,v);return}i?importScripts(i.createScriptURL(h)):importScripts(h),e()})}function C(){require.config({baseUrl:M,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}function o(e){p().then(()=>{C(),require([e],function(v){setTimeout(function(){const h=v.create((m,w)=>{self.postMessage(m,w)},null);for(self.onmessage=m=>h.onmessage(m.data,m.ports);S.length>0;)self.onmessage(S.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&C();let f=!0;const S=[];self.onmessage=e=>{if(!f){S.push(e);return}f=!1,o(e.data)}}(),Y(X[23],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function A(k,I=0){return k[k.length-(1+I)]}n.tail=A;function M(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}n.tail2=M;function i(k,I,T=(W,z)=>W===z){if(k===I)return!0;if(!k||!I||k.length!==I.length)return!1;for(let W=0,z=k.length;W<z;W++)if(!T(k[W],I[W]))return!1;return!0}n.equals=i;function c(k,I){const T=k.length-1;I<T&&(k[I]=k[T]),k.pop()}n.removeFastWithoutKeepingOrder=c;function p(k,I,T){return C(k.length,W=>T(k[W],I))}n.binarySearch=p;function C(k,I){let T=0,W=k-1;for(;T<=W;){const z=(T+W)/2|0,t=I(z);if(t<0)T=z+1;else if(t>0)W=z-1;else return z}return-(T+1)}n.binarySearch2=C;function o(k,I){let T=0,W=k.length;if(W===0)return 0;for(;T<W;){const z=Math.floor((T+W)/2);I(k[z])?W=z:T=z+1}return T}n.findFirstInSorted=o;function f(k,I,T){if(k=k|0,k>=I.length)throw new TypeError("invalid index");const W=I[Math.floor(I.length*Math.random())],z=[],t=[],se=[];for(const ge of I){const me=T(ge,W);me<0?z.push(ge):me>0?t.push(ge):se.push(ge)}return k<z.length?f(k,z,T):k<z.length+se.length?se[0]:f(k-(z.length+se.length),t,T)}n.quickSelect=f;function S(k,I){const T=[];let W;for(const z of k.slice(0).sort(I))!W||I(W[0],z)!==0?(W=[z],T.push(W)):W.push(z);return T}n.groupBy=S;function e(k){return k.filter(I=>!!I)}n.coalesce=e;function v(k){return!Array.isArray(k)||k.length===0}n.isFalsyOrEmpty=v;function h(k){return Array.isArray(k)&&k.length>0}n.isNonEmptyArray=h;function m(k,I=T=>T){const T=new Set;return k.filter(W=>{const z=I(W);return T.has(z)?!1:(T.add(z),!0)})}n.distinct=m;function w(k,I){const T=y(k,I);if(T!==-1)return k[T]}n.findLast=w;function y(k,I){for(let T=k.length-1;T>=0;T--){const W=k[T];if(I(W))return T}return-1}n.lastIndex=y;function _(k,I){return k.length>0?k[0]:I}n.firstOrDefault=_;function g(k,I){let T=typeof I=="number"?k:0;typeof I=="number"?T=k:(T=0,I=k);const W=[];if(T<=I)for(let z=T;z<I;z++)W.push(z);else for(let z=T;z>I;z--)W.push(z);return W}n.range=g;function L(k,I,T){const W=k.slice(0,I),z=k.slice(I);return W.concat(T,z)}n.arrayInsert=L;function l(k,I){const T=k.indexOf(I);T>-1&&(k.splice(T,1),k.unshift(I))}n.pushToStart=l;function d(k,I){const T=k.indexOf(I);T>-1&&(k.splice(T,1),k.push(I))}n.pushToEnd=d;function s(k,I){for(const T of I)k.push(T)}n.pushMany=s;function a(k){return Array.isArray(k)?k:[k]}n.asArray=a;function r(k,I,T){const W=b(k,I),z=k.length,t=T.length;k.length=z+t;for(let se=z-1;se>=W;se--)k[se+t]=k[se];for(let se=0;se<t;se++)k[se+W]=T[se]}n.insertInto=r;function u(k,I,T,W){const z=b(k,I),t=k.splice(z,T);return r(k,z,W),t}n.splice=u;function b(k,I){return I<0?Math.max(I+k.length,0):Math.min(I,k.length)}var N;(function(k){function I(z){return z<0}k.isLessThan=I;function T(z){return z>0}k.isGreaterThan=T;function W(z){return z===0}k.isNeitherLessOrGreaterThan=W,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(N=n.CompareResult||(n.CompareResult={}));function R(k,I){return(T,W)=>I(k(T),k(W))}n.compareBy=R;const E=(k,I)=>k-I;n.numberComparator=E;function P(k,I){if(k.length===0)return;let T=k[0];for(let W=1;W<k.length;W++){const z=k[W];I(z,T)>0&&(T=z)}return T}n.findMaxBy=P;function F(k,I){if(k.length===0)return;let T=k[0];for(let W=1;W<k.length;W++){const z=k[W];I(z,T)>=0&&(T=z)}return T}n.findLastMaxBy=F;function x(k,I){return P(k,(T,W)=>-I(T,W))}n.findMinBy=x;class O{constructor(I){this.f=I,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(I){let T=this.c;for(;T<this.f.length&&I(this.f[T]);)T++;const W=T===this.c?null:this.f.slice(this.c,T);return this.c=T,W}takeFromEndWhile(I){let T=this.d;for(;T>=0&&I(this.f[T]);)T--;const W=T===this.d?null:this.f.slice(T+1,this.d+1);return this.d=T,W}peek(){if(this.length!==0)return this.f[this.c]}dequeue(){const I=this.f[this.c];return this.c++,I}takeCount(I){const T=this.f.slice(this.c,this.c+I);return this.c+=I,T}}n.ArrayQueue=O;class q{constructor(I){this.iterate=I}toArray(){const I=[];return this.iterate(T=>(I.push(T),!0)),I}filter(I){return new q(T=>this.iterate(W=>I(W)?T(W):!0))}map(I){return new q(T=>this.iterate(W=>T(I(W))))}findLast(I){let T;return this.iterate(W=>(I(W)&&(T=W),!0)),T}findLastMaxBy(I){let T,W=!0;return this.iterate(z=>((W||N.isGreaterThan(I(z,T)))&&(W=!1,T=z),!0)),T}}n.CallbackIterable=q,q.empty=new q(k=>{})}),Y(X[24],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class A{constructor(c){this.c=c,this.a=void 0,this.b=void 0}get(c){const p=JSON.stringify(c);return this.b!==p&&(this.b=p,this.a=this.c(c)),this.a}}n.LRUCachedFunction=A;class M{get cachedValues(){return this.a}constructor(c){this.b=c,this.a=new Map}get(c){if(this.a.has(c))return this.a.get(c);const p=this.b(c);return this.a.set(c,p),p}}n.CachedFunction=M}),Y(X[25],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class A{constructor(i,c,p,C){this.originalStart=i,this.originalLength=c,this.modifiedStart=p,this.modifiedLength=C}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=A}),Y(X[8],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class A{constructor(){this.b=[],this.a=function(y){setTimeout(()=>{throw y.stack?h.isErrorNoTelemetry(y)?new h(y.message+`

`+y.stack):new Error(y.message+`

`+y.stack):y},0)}}c(y){this.b.forEach(_=>{_(y)})}onUnexpectedError(y){this.a(y),this.c(y)}onUnexpectedExternalError(y){this.a(y)}}n.ErrorHandler=A,n.errorHandler=new A;function M(w){C(w)||n.errorHandler.onUnexpectedError(w)}n.onUnexpectedError=M;function i(w){C(w)||n.errorHandler.onUnexpectedExternalError(w)}n.onUnexpectedExternalError=i;function c(w){if(w instanceof Error){const{name:y,message:_}=w,g=w.stacktrace||w.stack;return{$isError:!0,name:y,message:_,stack:g,noTelemetry:h.isErrorNoTelemetry(w)}}return w}n.transformErrorForSerialization=c;const p="Canceled";function C(w){return w instanceof o?!0:w instanceof Error&&w.name===p&&w.message===p}n.isCancellationError=C;class o extends Error{constructor(){super(p),this.name=this.message}}n.CancellationError=o;function f(){const w=new Error(p);return w.name=w.message,w}n.canceled=f;function S(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}n.illegalArgument=S;function e(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}n.illegalState=e;class v extends Error{constructor(y){super("NotSupported"),y&&(this.message=y)}}n.NotSupportedError=v;class h extends Error{constructor(y){super(y),this.name="CodeExpectedError"}static fromError(y){if(y instanceof h)return y;const _=new h;return _.message=y.message,_.stack=y.stack,_}static isErrorNoTelemetry(y){return y.name==="CodeExpectedError"}}n.ErrorNoTelemetry=h;class m extends Error{constructor(y){super(y||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype);debugger}}n.BugIndicatingError=m}),Y(X[9],Q([0,1,8]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function M(C,o){if(!C)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}n.ok=M;function i(C,o="Unreachable"){throw new Error(o)}n.assertNever=i;function c(C){if(!C()){debugger;C(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}n.assertFn=c;function p(C,o){let f=0;for(;f<C.length-1;){const S=C[f],e=C[f+1];if(!o(S,e))return!1;f++}return!0}n.checkAdjacentItems=p}),Y(X[26],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function A(M){const i=this;let c=!1,p;return function(){return c||(c=!0,p=M.apply(i,arguments)),p}}n.once=A}),Y(X[13],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var A;(function(M){function i(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}M.is=i;const c=Object.freeze([]);function p(){return c}M.empty=p;function*C(l){yield l}M.single=C;function o(l){return i(l)?l:C(l)}M.wrap=o;function f(l){return l||c}M.from=f;function S(l){return!l||l[Symbol.iterator]().next().done===!0}M.isEmpty=S;function e(l){return l[Symbol.iterator]().next().value}M.first=e;function v(l,d){for(const s of l)if(d(s))return!0;return!1}M.some=v;function h(l,d){for(const s of l)if(d(s))return s}M.find=h;function*m(l,d){for(const s of l)d(s)&&(yield s)}M.filter=m;function*w(l,d){let s=0;for(const a of l)yield d(a,s++)}M.map=w;function*y(...l){for(const d of l)for(const s of d)yield s}M.concat=y;function _(l,d,s){let a=s;for(const r of l)a=d(a,r);return a}M.reduce=_;function*g(l,d,s=l.length){for(d<0&&(d+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);d<s;d++)yield l[d]}M.slice=g;function L(l,d=Number.POSITIVE_INFINITY){const s=[];if(d===0)return[s,l];const a=l[Symbol.iterator]();for(let r=0;r<d;r++){const u=a.next();if(u.done)return[s,M.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return a}}]}M.consume=L})(A=n.Iterable||(n.Iterable={}))}),Y(X[27],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(v,h){this._keyCodeToStr[v]=h,this._strToKeyCode[h.toLowerCase()]=v}keyCodeToStr(v){return this._keyCodeToStr[v]}strToKeyCode(v){return this._strToKeyCode[v.toLowerCase()]||0}}const M=new A,i=new A,c=new A;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const p=[],C=Object.create(null),o=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",v=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],h=[],m=[];for(const w of v){const[y,_,g,L,l,d,s,a,r,u]=w;if(m[g]||(m[g]=!0,p[g]=L,C[L]=g,o[L.toLowerCase()]=g,_&&(n.IMMUTABLE_CODE_TO_KEY_CODE[g]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[l]=g))),!h[l]){if(h[l]=!0,!d)throw new Error(`String representation missing for key code ${l} around scan code ${L}`);M.define(l,d),i.define(l,r||d),c.define(l,u||r||d)}s&&(n.EVENT_KEY_CODE_MAP[s]=l),a&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[a]=l)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var f;(function(e){function v(g){return M.keyCodeToStr(g)}e.toString=v;function h(g){return M.strToKeyCode(g)}e.fromString=h;function m(g){return i.keyCodeToStr(g)}e.toUserSettingsUS=m;function w(g){return c.keyCodeToStr(g)}e.toUserSettingsGeneral=w;function y(g){return i.strToKeyCode(g)||c.strToKeyCode(g)}e.fromUserSettings=y;function _(g){if(g>=93&&g<=108)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(g)}e.toElectronAccelerator=_})(f=n.KeyCodeUtils||(n.KeyCodeUtils={}));function S(e,v){const h=(v&65535)<<16>>>0;return(e|h)>>>0}n.KeyChord=S}),Y(X[28],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class A{constructor(i){this.d=i,this.a=!1}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}n.Lazy=A}),Y(X[10],Q([0,1,26,13]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let c=null;function p(a){c=a}if(n.setDisposableTracker=p,i){const a="__is_disposable_tracked__";p(new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(u)},3e3)}setParent(r,u){if(r&&r!==_.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==_.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function C(a){return c?.trackDisposable(a),a}function o(a){c?.markAsDisposed(a)}function f(a,r){c?.setParent(a,r)}function S(a,r){if(!!c)for(const u of a)c.setParent(u,r)}function e(a){return c?.markAsSingleton(a),a}n.markAsSingleton=e;function v(a){return typeof a.dispose=="function"&&a.dispose.length===0}n.isDisposable=v;function h(a){if(M.Iterable.is(a)){const r=[];for(const u of a)if(u)try{u.dispose()}catch(b){r.push(b)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}n.dispose=h;function m(...a){const r=w(()=>h(a));return S(a,r),r}n.combinedDisposable=m;function w(a){const r=C({dispose:(0,A.once)(()=>{o(r),a()})});return r}n.toDisposable=w;class y{constructor(){this.a=new Set,this.b=!1,C(this)}dispose(){this.b||(o(this),this.b=!0,this.clear())}get isDisposed(){return this.b}clear(){if(this.a.size!==0)try{h(this.a)}finally{this.a.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return f(r,this),this.b?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.a.add(r),r}}n.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this.f=new y,C(this),f(this.f,this)}dispose(){o(this),this.f.dispose()}q(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.f.add(r)}}n.Disposable=_,_.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(r){var u;this.b||r===this.a||((u=this.a)===null||u===void 0||u.dispose(),r&&f(r,this),this.a=r)}clear(){this.value=void 0}dispose(){var r;this.b=!0,o(this),(r=this.a)===null||r===void 0||r.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&f(r,null),r}}n.MutableDisposable=g;class L{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}n.RefCountedDisposable=L;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(r){let u=r;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,o(this))},this}}n.SafeDisposable=l;class d{constructor(r){this.object=r}dispose(){}}n.ImmortalReference=d;class s{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}get(r){return this.a.get(r)}set(r,u,b=!1){var N;this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||(N=this.a.get(r))===null||N===void 0||N.dispose(),this.a.set(r,u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}n.DisposableMap=s}),Y(X[14],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class A{constructor(c){this.element=c,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class M{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let c=this.a;for(;c!==A.Undefined;){const p=c.next;c.prev=A.Undefined,c.next=A.Undefined,c=p}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(c){return this.d(c,!1)}push(c){return this.d(c,!0)}d(c,p){const C=new A(c);if(this.a===A.Undefined)this.a=C,this.b=C;else if(p){const f=this.b;this.b=C,C.prev=f,f.next=C}else{const f=this.a;this.a=C,C.next=f,f.prev=C}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(C))}}shift(){if(this.a!==A.Undefined){const c=this.a.element;return this.e(this.a),c}}pop(){if(this.b!==A.Undefined){const c=this.b.element;return this.e(this.b),c}}e(c){if(c.prev!==A.Undefined&&c.next!==A.Undefined){const p=c.prev;p.next=c.next,c.next.prev=p}else c.prev===A.Undefined&&c.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):c.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):c.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let c=this.a;for(;c!==A.Undefined;)yield c.element,c=c.next}}n.LinkedList=M}),Y(X[4],Q([0,1,24,28]),function(U,n,A,M){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function c(D){return!D||typeof D!="string"?!0:D.trim().length===0}n.isFalsyOrWhitespace=c;const p=/{(\d+)}/g;function C(D,...B){return B.length===0?D:D.replace(p,function(V,j){const Z=parseInt(j,10);return isNaN(Z)||Z<0||Z>=B.length?V:B[Z]})}n.format=C;function o(D){return D.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=o;function f(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=f;function S(D,B=" "){const V=e(D,B);return v(V,B)}n.trim=S;function e(D,B){if(!D||!B)return D;const V=B.length;if(V===0||D.length===0)return D;let j=0;for(;D.indexOf(B,j)===j;)j=j+V;return D.substring(j)}n.ltrim=e;function v(D,B){if(!D||!B)return D;const V=B.length,j=D.length;if(V===0||j===0)return D;let Z=j,ie=-1;for(;ie=D.lastIndexOf(B,Z-1),!(ie===-1||ie+V!==Z);){if(ie===0)return"";Z=ie}return D.substring(0,Z)}n.rtrim=v;function h(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=h;function m(D){return D.replace(/\*/g,"")}n.stripWildcards=m;function w(D,B,V={}){if(!D)throw new Error("Cannot create regex from empty string");B||(D=f(D)),V.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let j="";return V.global&&(j+="g"),V.matchCase||(j+="i"),V.multiline&&(j+="m"),V.unicode&&(j+="u"),new RegExp(D,j)}n.createRegExp=w;function y(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}n.regExpLeadsToEndlessLoop=y;function _(D){return(D.global?"g":"")+(D.ignoreCase?"i":"")+(D.multiline?"m":"")+(D.unicode?"u":"")}n.regExpFlags=_;function g(D){return D.split(/\r\n|\r|\n/)}n.splitLines=g;function L(D){for(let B=0,V=D.length;B<V;B++){const j=D.charCodeAt(B);if(j!==32&&j!==9)return B}return-1}n.firstNonWhitespaceIndex=L;function l(D,B=0,V=D.length){for(let j=B;j<V;j++){const Z=D.charCodeAt(j);if(Z!==32&&Z!==9)return D.substring(B,j)}return D.substring(B,V)}n.getLeadingWhitespace=l;function d(D,B=D.length-1){for(let V=B;V>=0;V--){const j=D.charCodeAt(V);if(j!==32&&j!==9)return V}return-1}n.lastNonWhitespaceIndex=d;function s(D,B){return D<B?-1:D>B?1:0}n.compare=s;function a(D,B,V=0,j=D.length,Z=0,ie=B.length){for(;V<j&&Z<ie;V++,Z++){const fe=D.charCodeAt(V),re=B.charCodeAt(Z);if(fe<re)return-1;if(fe>re)return 1}const oe=j-V,ve=ie-Z;return oe<ve?-1:oe>ve?1:0}n.compareSubstring=a;function r(D,B){return u(D,B,0,D.length,0,B.length)}n.compareIgnoreCase=r;function u(D,B,V=0,j=D.length,Z=0,ie=B.length){for(;V<j&&Z<ie;V++,Z++){let fe=D.charCodeAt(V),re=B.charCodeAt(Z);if(fe===re)continue;if(fe>=128||re>=128)return a(D.toLowerCase(),B.toLowerCase(),V,j,Z,ie);N(fe)&&(fe-=32),N(re)&&(re-=32);const ce=fe-re;if(ce!==0)return ce}const oe=j-V,ve=ie-Z;return oe<ve?-1:oe>ve?1:0}n.compareSubstringIgnoreCase=u;function b(D){return D>=48&&D<=57}n.isAsciiDigit=b;function N(D){return D>=97&&D<=122}n.isLowerAsciiLetter=N;function R(D){return D>=65&&D<=90}n.isUpperAsciiLetter=R;function E(D,B){return D.length===B.length&&u(D,B)===0}n.equalsIgnoreCase=E;function P(D,B){const V=B.length;return B.length>D.length?!1:u(D,B,0,V)===0}n.startsWithIgnoreCase=P;function F(D,B){const V=Math.min(D.length,B.length);let j;for(j=0;j<V;j++)if(D.charCodeAt(j)!==B.charCodeAt(j))return j;return V}n.commonPrefixLength=F;function x(D,B){const V=Math.min(D.length,B.length);let j;const Z=D.length-1,ie=B.length-1;for(j=0;j<V;j++)if(D.charCodeAt(Z-j)!==B.charCodeAt(ie-j))return j;return V}n.commonSuffixLength=x;function O(D){return 55296<=D&&D<=56319}n.isHighSurrogate=O;function q(D){return 56320<=D&&D<=57343}n.isLowSurrogate=q;function k(D,B){return(D-55296<<10)+(B-56320)+65536}n.computeCodePoint=k;function I(D,B,V){const j=D.charCodeAt(V);if(O(j)&&V+1<B){const Z=D.charCodeAt(V+1);if(q(Z))return k(j,Z)}return j}n.getNextCodePoint=I;function T(D,B){const V=D.charCodeAt(B-1);if(q(V)&&B>1){const j=D.charCodeAt(B-2);if(O(j))return k(j,V)}return V}class W{get offset(){return this.e}constructor(B,V=0){this.c=B,this.d=B.length,this.e=V}setOffset(B){this.e=B}prevCodePoint(){const B=T(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=I(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}n.CodePointIterator=W;class z{get offset(){return this.c.offset}constructor(B,V=0){this.c=new W(B,V)}nextGraphemeLength(){const B=ne.getInstance(),V=this.c,j=V.offset;let Z=B.getGraphemeBreakType(V.nextCodePoint());for(;!V.eol();){const ie=V.offset,oe=B.getGraphemeBreakType(V.nextCodePoint());if(te(Z,oe)){V.setOffset(ie);break}Z=oe}return V.offset-j}prevGraphemeLength(){const B=ne.getInstance(),V=this.c,j=V.offset;let Z=B.getGraphemeBreakType(V.prevCodePoint());for(;V.offset>0;){const ie=V.offset,oe=B.getGraphemeBreakType(V.prevCodePoint());if(te(oe,Z)){V.setOffset(ie);break}Z=oe}return j-V.offset}eol(){return this.c.eol()}}n.GraphemeIterator=z;function t(D,B){return new z(D,B).nextGraphemeLength()}n.nextCharLength=t;function se(D,B){return new z(D,B).prevGraphemeLength()}n.prevCharLength=se;function ge(D,B){B>0&&q(D.charCodeAt(B))&&B--;const V=B+t(D,B);return[V-se(D,V),V]}n.getCharContainingOffset=ge;let me;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(D){return me||(me=ye()),me.test(D)}n.containsRTL=Se;const Ne=/^[\t\n\r\x20-\x7E]*$/;function _e(D){return Ne.test(D)}n.isBasicASCII=_e,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(D){return n.UNUSUAL_LINE_TERMINATORS.test(D)}n.containsUnusualLineTerminators=J;function H(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}n.isFullWidthCharacter=H;function $(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}n.isEmojiImprecise=$,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function G(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}n.startsWithUTF8BOM=G;function K(D,B=!1){return D?(B&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}n.containsUppercaseCharacter=K;function ee(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}n.singleLetterHash=ee;function te(D,B){return D===0?B!==5&&B!==7:D===2&&B===3?!1:D===4||D===2||D===3||B===4||B===2||B===3?!0:!(D===8&&(B===8||B===9||B===11||B===12)||(D===11||D===9)&&(B===9||B===10)||(D===12||D===10)&&B===10||B===5||B===13||B===7||D===1||D===13&&B===14||D===6&&B===6)}class ne{static getInstance(){return ne.c||(ne.c=new ne),ne.c}constructor(){this.d=be()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const V=this.d,j=V.length/3;let Z=1;for(;Z<=j;)if(B<V[3*Z])Z=2*Z;else if(B>V[3*Z+1])Z=2*Z+1;else return V[3*Z+2];return 0}}ne.c=null;function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(D,B){if(D===0)return 0;const V=we(D,B);if(V!==void 0)return V;const j=new W(B,D);return j.prevCodePoint(),j.offset}n.getLeftDeleteOffset=Le;function we(D,B){const V=new W(B,D);let j=V.prevCodePoint();for(;Ce(j)||j===65039||j===8419;){if(V.offset===0)return;j=V.prevCodePoint()}if(!$(j))return;let Z=V.offset;return Z>0&&V.prevCodePoint()===8205&&(Z=V.offset),Z}function Ce(D){return 127995<=D&&D<=127999}n.noBreakWhitespace="\xA0";class ue{static getInstance(B){return ue.d.get(Array.from(B))}static getLocales(){return ue.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}n.AmbiguousCharacters=ue,i=ue,ue.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ue.d=new A.LRUCachedFunction(D=>{function B(re){const ce=new Map;for(let he=0;he<re.length;he+=2)ce.set(re[he],re[he+1]);return ce}function V(re,ce){const he=new Map(re);for(const[pe,Ae]of ce)he.set(pe,Ae);return he}function j(re,ce){if(!re)return ce;const he=new Map;for(const[pe,Ae]of re)ce.has(pe)&&he.set(pe,Ae);return he}const Z=i.c.value;let ie=D.filter(re=>!re.startsWith("_")&&re in Z);ie.length===0&&(ie=["_default"]);let oe;for(const re of ie){const ce=B(Z[re]);oe=j(oe,ce)}const ve=B(Z._common),fe=V(ve,oe);return new ue(fe)}),ue.e=new M.Lazy(()=>Object.keys(ue.c.value).filter(D=>!D.startsWith("_")));class de{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(de.c())),this.d}static isInvisibleCharacter(B){return de.e().has(B)}static get codePoints(){return de.e()}}n.InvisibleCharacters=de,de.d=void 0}),Y(X[29],Q([0,1,4]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(w){return i(w,0)}n.hash=M;function i(w,y){switch(typeof w){case"object":return w===null?c(349,y):Array.isArray(w)?o(w,y):f(w,y);case"string":return C(w,y);case"boolean":return p(w,y);case"number":return c(w,y);case"undefined":return c(937,y);default:return c(617,y)}}n.doHash=i;function c(w,y){return(y<<5)-y+w|0}n.numberHash=c;function p(w,y){return c(w?433:863,y)}function C(w,y){y=c(149417,y);for(let _=0,g=w.length;_<g;_++)y=c(w.charCodeAt(_),y);return y}n.stringHash=C;function o(w,y){return y=c(104579,y),w.reduce((_,g)=>i(g,_),y)}function f(w,y){return y=c(181387,y),Object.keys(w).sort().reduce((_,g)=>(_=C(g,_),i(w[g],_)),y)}function S(w,y,_=32){const g=_-y,L=~((1<<g)-1);return(w<<y|(L&w)>>>g)>>>0}function e(w,y=0,_=w.byteLength,g=0){for(let L=0;L<_;L++)w[y+L]=g}function v(w,y,_="0"){for(;w.length<y;)w=_+w;return w}function h(w,y=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(_=>_.toString(16).padStart(2,"0")).join(""):v((w>>>0).toString(16),y/4)}n.toHexString=h;class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(y){const _=y.length;if(_===0)return;const g=this.p;let L=this.r,l=this.u,d,s;for(l!==0?(d=l,s=-1,l=0):(d=y.charCodeAt(0),s=0);;){let a=d;if(A.isHighSurrogate(d))if(s+1<_){const r=y.charCodeAt(s+1);A.isLowSurrogate(r)?(s++,a=A.computeCodePoint(d,r)):a=65533}else{l=d;break}else A.isLowSurrogate(d)&&(a=65533);if(L=this.w(g,L,a),s++,s<_)d=y.charCodeAt(s);else break}this.r=L,this.u=l}w(y,_,g){return g<128?y[_++]=g:g<2048?(y[_++]=192|(g&1984)>>>6,y[_++]=128|(g&63)>>>0):g<65536?(y[_++]=224|(g&61440)>>>12,y[_++]=128|(g&4032)>>>6,y[_++]=128|(g&63)>>>0):(y[_++]=240|(g&1835008)>>>18,y[_++]=128|(g&258048)>>>12,y[_++]=128|(g&4032)>>>6,y[_++]=128|(g&63)>>>0),_>=64&&(this.y(),_-=64,this.t+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),_}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,e(this.p,this.r),this.r>56&&(this.y(),e(this.p));const y=8*this.t;this.q.setUint32(56,Math.floor(y/4294967296),!1),this.q.setUint32(60,y%4294967296,!1),this.y()}y(){const y=m.g,_=this.q;for(let b=0;b<64;b+=4)y.setUint32(b,_.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)y.setUint32(b,S(y.getUint32(b-12,!1)^y.getUint32(b-32,!1)^y.getUint32(b-56,!1)^y.getUint32(b-64,!1),1),!1);let g=this.h,L=this.l,l=this.m,d=this.n,s=this.o,a,r,u;for(let b=0;b<80;b++)b<20?(a=L&l|~L&d,r=1518500249):b<40?(a=L^l^d,r=1859775393):b<60?(a=L&l|L&d|l&d,r=2400959708):(a=L^l^d,r=3395469782),u=S(g,5)+a+s+r+y.getUint32(b*4,!1)&4294967295,s=d,d=l,l=S(L,30),L=g,g=u;this.h=this.h+g&4294967295,this.l=this.l+L&4294967295,this.m=this.m+l&4294967295,this.n=this.n+d&4294967295,this.o=this.o+s&4294967295}}n.StringSHA1=m,m.g=new DataView(new ArrayBuffer(320))}),Y(X[15],Q([0,1,25,29]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.a=e}getElements(){const e=this.a,v=new Int32Array(e.length);for(let h=0,m=e.length;h<m;h++)v[h]=e.charCodeAt(h);return v}}n.StringDiffSequence=i;function c(S,e,v){return new f(new i(S),new i(e)).ComputeDiff(v).changes}n.stringDiff=c;class p{static Assert(e,v){if(!e)throw new Error(v)}}class C{static Copy(e,v,h,m,w){for(let y=0;y<w;y++)h[m+y]=e[v+y]}static Copy2(e,v,h,m,w){for(let y=0;y<w;y++)h[m+y]=e[v+y]}}class o{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(e,v){this.b=Math.min(this.b,e),this.c=Math.min(this.c,v),this.d++}AddModifiedElement(e,v){this.b=Math.min(this.b,e),this.c=Math.min(this.c,v),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(e,v,h=null){this.a=h,this.b=e,this.c=v;const[m,w,y]=f.o(e),[_,g,L]=f.o(v);this.d=y&&L,this.e=m,this.f=w,this.g=_,this.h=g,this.k=[],this.m=[]}static n(e){return e.length>0&&typeof e[0]=="string"}static o(e){const v=e.getElements();if(f.n(v)){const h=new Int32Array(v.length);for(let m=0,w=v.length;m<w;m++)h[m]=(0,M.stringHash)(v[m],0);return[v,h,!0]}return v instanceof Int32Array?[[],v,!1]:[[],new Int32Array(v),!1]}p(e,v){return this.f[e]!==this.h[v]?!1:this.d?this.e[e]===this.g[v]:!0}q(e,v){if(!this.p(e,v))return!1;const h=f.r(this.b,e),m=f.r(this.c,v);return h===m}static r(e,v){return typeof e.getStrictElement=="function"?e.getStrictElement(v):null}s(e,v){return this.f[e]!==this.f[v]?!1:this.d?this.e[e]===this.e[v]:!0}u(e,v){return this.h[e]!==this.h[v]?!1:this.d?this.g[e]===this.g[v]:!0}ComputeDiff(e){return this.v(0,this.f.length-1,0,this.h.length-1,e)}v(e,v,h,m,w){const y=[!1];let _=this.w(e,v,h,m,y);return w&&(_=this.z(_)),{quitEarly:y[0],changes:_}}w(e,v,h,m,w){for(w[0]=!1;e<=v&&h<=m&&this.p(e,h);)e++,h++;for(;v>=e&&m>=h&&this.p(v,m);)v--,m--;if(e>v||h>m){let d;return h<=m?(p.Assert(e===v+1,"originalStart should only be one more than originalEnd"),d=[new A.DiffChange(e,0,h,m-h+1)]):e<=v?(p.Assert(h===m+1,"modifiedStart should only be one more than modifiedEnd"),d=[new A.DiffChange(e,v-e+1,h,0)]):(p.Assert(e===v+1,"originalStart should only be one more than originalEnd"),p.Assert(h===m+1,"modifiedStart should only be one more than modifiedEnd"),d=[]),d}const y=[0],_=[0],g=this.y(e,v,h,m,y,_,w),L=y[0],l=_[0];if(g!==null)return g;if(!w[0]){const d=this.w(e,L,h,l,w);let s=[];return w[0]?s=[new A.DiffChange(L+1,v-(L+1)+1,l+1,m-(l+1)+1)]:s=this.w(L+1,v,l+1,m,w),this.H(d,s)}return[new A.DiffChange(e,v-e+1,h,m-h+1)]}x(e,v,h,m,w,y,_,g,L,l,d,s,a,r,u,b,N,R){let E=null,P=null,F=new o,x=v,O=h,q=a[0]-b[0]-m,k=-1073741824,I=this.k.length-1;do{const T=q+e;T===x||T<O&&L[T-1]<L[T+1]?(d=L[T+1],r=d-q-m,d<k&&F.MarkNextChange(),k=d,F.AddModifiedElement(d+1,r),q=T+1-e):(d=L[T-1]+1,r=d-q-m,d<k&&F.MarkNextChange(),k=d-1,F.AddOriginalElement(d,r+1),q=T-1-e),I>=0&&(L=this.k[I],e=L[0],x=1,O=L.length-1)}while(--I>=-1);if(E=F.getReverseChanges(),R[0]){let T=a[0]+1,W=b[0]+1;if(E!==null&&E.length>0){const z=E[E.length-1];T=Math.max(T,z.getOriginalEnd()),W=Math.max(W,z.getModifiedEnd())}P=[new A.DiffChange(T,s-T+1,W,u-W+1)]}else{F=new o,x=y,O=_,q=a[0]-b[0]-g,k=1073741824,I=N?this.m.length-1:this.m.length-2;do{const T=q+w;T===x||T<O&&l[T-1]>=l[T+1]?(d=l[T+1]-1,r=d-q-g,d>k&&F.MarkNextChange(),k=d+1,F.AddOriginalElement(d+1,r+1),q=T+1-w):(d=l[T-1],r=d-q-g,d>k&&F.MarkNextChange(),k=d,F.AddModifiedElement(d+1,r+1),q=T-1-w),I>=0&&(l=this.m[I],w=l[0],x=1,O=l.length-1)}while(--I>=-1);P=F.getChanges()}return this.H(E,P)}y(e,v,h,m,w,y,_){let g=0,L=0,l=0,d=0,s=0,a=0;e--,h--,w[0]=0,y[0]=0,this.k=[],this.m=[];const r=v-e+(m-h),u=r+1,b=new Int32Array(u),N=new Int32Array(u),R=m-h,E=v-e,P=e-h,F=v-m,O=(E-R)%2===0;b[R]=e,N[E]=v,_[0]=!1;for(let q=1;q<=r/2+1;q++){let k=0,I=0;l=this.J(R-q,q,R,u),d=this.J(R+q,q,R,u);for(let W=l;W<=d;W+=2){W===l||W<d&&b[W-1]<b[W+1]?g=b[W+1]:g=b[W-1]+1,L=g-(W-R)-P;const z=g;for(;g<v&&L<m&&this.p(g+1,L+1);)g++,L++;if(b[W]=g,g+L>k+I&&(k=g,I=L),!O&&Math.abs(W-E)<=q-1&&g>=N[W])return w[0]=g,y[0]=L,z<=N[W]&&1447>0&&q<=1447+1?this.x(R,l,d,P,E,s,a,F,b,N,g,v,w,L,m,y,O,_):null}const T=(k-e+(I-h)-q)/2;if(this.a!==null&&!this.a(k,T))return _[0]=!0,w[0]=k,y[0]=I,T>0&&1447>0&&q<=1447+1?this.x(R,l,d,P,E,s,a,F,b,N,g,v,w,L,m,y,O,_):(e++,h++,[new A.DiffChange(e,v-e+1,h,m-h+1)]);s=this.J(E-q,q,E,u),a=this.J(E+q,q,E,u);for(let W=s;W<=a;W+=2){W===s||W<a&&N[W-1]>=N[W+1]?g=N[W+1]-1:g=N[W-1],L=g-(W-E)-F;const z=g;for(;g>e&&L>h&&this.p(g,L);)g--,L--;if(N[W]=g,O&&Math.abs(W-R)<=q&&g<=b[W])return w[0]=g,y[0]=L,z>=b[W]&&1447>0&&q<=1447+1?this.x(R,l,d,P,E,s,a,F,b,N,g,v,w,L,m,y,O,_):null}if(q<=1447){let W=new Int32Array(d-l+2);W[0]=R-l+1,C.Copy2(b,l,W,1,d-l+1),this.k.push(W),W=new Int32Array(a-s+2),W[0]=E-s+1,C.Copy2(N,s,W,1,a-s+1),this.m.push(W)}}return this.x(R,l,d,P,E,s,a,F,b,N,g,v,w,L,m,y,O,_)}z(e){for(let v=0;v<e.length;v++){const h=e[v],m=v<e.length-1?e[v+1].originalStart:this.f.length,w=v<e.length-1?e[v+1].modifiedStart:this.h.length,y=h.originalLength>0,_=h.modifiedLength>0;for(;h.originalStart+h.originalLength<m&&h.modifiedStart+h.modifiedLength<w&&(!y||this.s(h.originalStart,h.originalStart+h.originalLength))&&(!_||this.u(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const L=this.q(h.originalStart,h.modifiedStart);if(this.q(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!L)break;h.originalStart++,h.modifiedStart++}const g=[null];if(v<e.length-1&&this.I(e[v],e[v+1],g)){e[v]=g[0],e.splice(v+1,1),v--;continue}}for(let v=e.length-1;v>=0;v--){const h=e[v];let m=0,w=0;if(v>0){const d=e[v-1];m=d.originalStart+d.originalLength,w=d.modifiedStart+d.modifiedLength}const y=h.originalLength>0,_=h.modifiedLength>0;let g=0,L=this.G(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let d=1;;d++){const s=h.originalStart-d,a=h.modifiedStart-d;if(s<m||a<w||y&&!this.s(s,s+h.originalLength)||_&&!this.u(a,a+h.modifiedLength))break;const u=(s===m&&a===w?5:0)+this.G(s,h.originalLength,a,h.modifiedLength);u>L&&(L=u,g=d)}h.originalStart-=g,h.modifiedStart-=g;const l=[null];if(v>0&&this.I(e[v-1],e[v],l)){e[v-1]=l[0],e.splice(v,1),v++;continue}}if(this.d)for(let v=1,h=e.length;v<h;v++){const m=e[v-1],w=e[v],y=w.originalStart-m.originalStart-m.originalLength,_=m.originalStart,g=w.originalStart+w.originalLength,L=g-_,l=m.modifiedStart,d=w.modifiedStart+w.modifiedLength,s=d-l;if(y<5&&L<20&&s<20){const a=this.A(_,L,l,s,y);if(a){const[r,u]=a;(r!==m.originalStart+m.originalLength||u!==m.modifiedStart+m.modifiedLength)&&(m.originalLength=r-m.originalStart,m.modifiedLength=u-m.modifiedStart,w.originalStart=r+y,w.modifiedStart=u+y,w.originalLength=g-w.originalStart,w.modifiedLength=d-w.modifiedStart)}}}return e}A(e,v,h,m,w){if(v<w||m<w)return null;const y=e+v-w+1,_=h+m-w+1;let g=0,L=0,l=0;for(let d=e;d<y;d++)for(let s=h;s<_;s++){const a=this.B(d,s,w);a>0&&a>g&&(g=a,L=d,l=s)}return g>0?[L,l]:null}B(e,v,h){let m=0;for(let w=0;w<h;w++){if(!this.p(e+w,v+w))return 0;m+=this.e[e+w].length}return m}C(e){return e<=0||e>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[e])}D(e,v){if(this.C(e)||this.C(e-1))return!0;if(v>0){const h=e+v;if(this.C(h-1)||this.C(h))return!0}return!1}E(e){return e<=0||e>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[e])}F(e,v){if(this.E(e)||this.E(e-1))return!0;if(v>0){const h=e+v;if(this.E(h-1)||this.E(h))return!0}return!1}G(e,v,h,m){const w=this.D(e,v)?1:0,y=this.F(h,m)?1:0;return w+y}H(e,v){const h=[];if(e.length===0||v.length===0)return v.length>0?v:e;if(this.I(e[e.length-1],v[0],h)){const m=new Array(e.length+v.length-1);return C.Copy(e,0,m,0,e.length-1),m[e.length-1]=h[0],C.Copy(v,1,m,e.length,v.length-1),m}else{const m=new Array(e.length+v.length);return C.Copy(e,0,m,0,e.length),C.Copy(v,0,m,e.length,v.length),m}}I(e,v,h){if(p.Assert(e.originalStart<=v.originalStart,"Left change is not less than or equal to right change"),p.Assert(e.modifiedStart<=v.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=v.originalStart||e.modifiedStart+e.modifiedLength>=v.modifiedStart){const m=e.originalStart;let w=e.originalLength;const y=e.modifiedStart;let _=e.modifiedLength;return e.originalStart+e.originalLength>=v.originalStart&&(w=v.originalStart+v.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=v.modifiedStart&&(_=v.modifiedStart+v.modifiedLength-e.modifiedStart),h[0]=new A.DiffChange(m,w,y,_),!0}else return h[0]=null,!1}J(e,v,h,m){if(e>=0&&e<m)return e;const w=h,y=m-h-1,_=v%2===0;if(e<0){const g=w%2===0;return _===g?0:1}else{const g=y%2===0;return _===g?m-1:m-2}}}n.LcsDiff=f}),Y(X[16],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function A(_){return typeof _=="string"}n.isString=A;function M(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}n.isObject=M;function i(_){const g=Object.getPrototypeOf(Uint8Array);return typeof _=="object"&&_ instanceof g}n.isTypedArray=i;function c(_){return typeof _=="number"&&!isNaN(_)}n.isNumber=c;function p(_){return!!_&&typeof _[Symbol.iterator]=="function"}n.isIterable=p;function C(_){return _===!0||_===!1}n.isBoolean=C;function o(_){return typeof _>"u"}n.isUndefined=o;function f(_){return!S(_)}n.isDefined=f;function S(_){return o(_)||_===null}n.isUndefinedOrNull=S;function e(_,g){if(!_)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}n.assertType=e;function v(_){if(S(_))throw new Error("Assertion Failed: argument is undefined or null");return _}n.assertIsDefined=v;function h(_){return typeof _=="function"}n.isFunction=h;function m(_,g){const L=Math.min(_.length,g.length);for(let l=0;l<L;l++)w(_[l],g[l])}n.validateConstraints=m;function w(_,g){if(A(g)){if(typeof _!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(h(g)){try{if(_ instanceof g)return}catch{}if(!S(_)&&_.constructor===g||g.length===1&&g.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=w;function y(_){return _===null?void 0:_}n.withNullAsUndefined=y}),Y(X[30],Q([0,1,16]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(p,C){if((0,A.isString)(C)){const o=M[C];if(o===void 0)throw new Error(`${p} references an unknown codicon: ${C}`);C=o}return M[p]=C,{id:p}}function c(){return M}n.getCodiconFontCharacters=c,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(X[11],Q([0,1,16]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([w,y])=>{m[w]=y&&typeof y=="object"?M(y):y}),m}n.deepClone=M;function i(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const w=m.shift();Object.freeze(w);for(const y in w)if(c.call(w,y)){const _=w[y];typeof _=="object"&&!Object.isFrozen(_)&&!(0,A.isTypedArray)(_)&&m.push(_)}}return h}n.deepFreeze=i;const c=Object.prototype.hasOwnProperty;function p(h,m){return C(h,m,new Set)}n.cloneAndChange=p;function C(h,m,w){if((0,A.isUndefinedOrNull)(h))return h;const y=m(h);if(typeof y<"u")return y;if(Array.isArray(h)){const _=[];for(const g of h)_.push(C(g,m,w));return _}if((0,A.isObject)(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const _={};for(const g in h)c.call(h,g)&&(_[g]=C(h[g],m,w));return w.delete(h),_}return h}function o(h,m,w=!0){return(0,A.isObject)(h)?((0,A.isObject)(m)&&Object.keys(m).forEach(y=>{y in h?w&&((0,A.isObject)(h[y])&&(0,A.isObject)(m[y])?o(h[y],m[y],w):h[y]=m[y]):h[y]=m[y]}),h):m}n.mixin=o;function f(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let w,y;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(w=0;w<h.length;w++)if(!f(h[w],m[w]))return!1}else{const _=[];for(y in h)_.push(y);_.sort();const g=[];for(y in m)g.push(y);if(g.sort(),!f(_,g))return!1;for(w=0;w<_.length;w++)if(!f(h[_[w]],m[_[w]]))return!1}return!0}n.equals=f;function S(h){let m=[],w=Object.getPrototypeOf(h);for(;Object.prototype!==w;)m=m.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return m}n.getAllPropertyNames=S;function e(h){const m=[];for(const w of S(h))typeof h[w]=="function"&&m.push(w);return m}n.getAllMethodNames=e;function v(h,m){const w=_=>function(){const g=Array.prototype.slice.call(arguments,0);return m(_,g)},y={};for(const _ of h)y[_]=w(_);return y}n.createProxyObject=v}),Y(X[17],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function A(i){return i<0?0:i>255?255:i|0}n.toUint8=A;function M(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=M}),Y(X[18],Q([0,1,17]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(p){const C=(0,A.toUint8)(p);this.c=C,this.a=M.d(C),this.b=new Map}static d(p){const C=new Uint8Array(256);return C.fill(p),C}set(p,C){const o=(0,A.toUint8)(C);p>=0&&p<256?this.a[p]=o:this.b.set(p,o)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}n.CharacterClassifier=M;class i{constructor(){this.a=new M(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}n.CharacterSet=i}),Y(X[3],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class A{constructor(i,c){this.lineNumber=i,this.column=c}with(i=this.lineNumber,c=this.column){return i===this.lineNumber&&c===this.column?this:new A(i,c)}delta(i=0,c=0){return this.with(this.lineNumber+i,this.column+c)}equals(i){return A.equals(this,i)}static equals(i,c){return!i&&!c?!0:!!i&&!!c&&i.lineNumber===c.lineNumber&&i.column===c.column}isBefore(i){return A.isBefore(this,i)}static isBefore(i,c){return i.lineNumber<c.lineNumber?!0:c.lineNumber<i.lineNumber?!1:i.column<c.column}isBeforeOrEqual(i){return A.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,c){return i.lineNumber<c.lineNumber?!0:c.lineNumber<i.lineNumber?!1:i.column<=c.column}static compare(i,c){const p=i.lineNumber|0,C=c.lineNumber|0;if(p===C){const o=i.column|0,f=c.column|0;return o-f}return p-C}clone(){return new A(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new A(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=A}),Y(X[2],Q([0,1,3]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(c,p,C,o){c>C||c===C&&p>o?(this.startLineNumber=C,this.startColumn=o,this.endLineNumber=c,this.endColumn=p):(this.startLineNumber=c,this.startColumn=p,this.endLineNumber=C,this.endColumn=o)}isEmpty(){return M.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return M.containsPosition(this,c)}static containsPosition(c,p){return!(p.lineNumber<c.startLineNumber||p.lineNumber>c.endLineNumber||p.lineNumber===c.startLineNumber&&p.column<c.startColumn||p.lineNumber===c.endLineNumber&&p.column>c.endColumn)}static strictContainsPosition(c,p){return!(p.lineNumber<c.startLineNumber||p.lineNumber>c.endLineNumber||p.lineNumber===c.startLineNumber&&p.column<=c.startColumn||p.lineNumber===c.endLineNumber&&p.column>=c.endColumn)}containsRange(c){return M.containsRange(this,c)}static containsRange(c,p){return!(p.startLineNumber<c.startLineNumber||p.endLineNumber<c.startLineNumber||p.startLineNumber>c.endLineNumber||p.endLineNumber>c.endLineNumber||p.startLineNumber===c.startLineNumber&&p.startColumn<c.startColumn||p.endLineNumber===c.endLineNumber&&p.endColumn>c.endColumn)}strictContainsRange(c){return M.strictContainsRange(this,c)}static strictContainsRange(c,p){return!(p.startLineNumber<c.startLineNumber||p.endLineNumber<c.startLineNumber||p.startLineNumber>c.endLineNumber||p.endLineNumber>c.endLineNumber||p.startLineNumber===c.startLineNumber&&p.startColumn<=c.startColumn||p.endLineNumber===c.endLineNumber&&p.endColumn>=c.endColumn)}plusRange(c){return M.plusRange(this,c)}static plusRange(c,p){let C,o,f,S;return p.startLineNumber<c.startLineNumber?(C=p.startLineNumber,o=p.startColumn):p.startLineNumber===c.startLineNumber?(C=p.startLineNumber,o=Math.min(p.startColumn,c.startColumn)):(C=c.startLineNumber,o=c.startColumn),p.endLineNumber>c.endLineNumber?(f=p.endLineNumber,S=p.endColumn):p.endLineNumber===c.endLineNumber?(f=p.endLineNumber,S=Math.max(p.endColumn,c.endColumn)):(f=c.endLineNumber,S=c.endColumn),new M(C,o,f,S)}intersectRanges(c){return M.intersectRanges(this,c)}static intersectRanges(c,p){let C=c.startLineNumber,o=c.startColumn,f=c.endLineNumber,S=c.endColumn;const e=p.startLineNumber,v=p.startColumn,h=p.endLineNumber,m=p.endColumn;return C<e?(C=e,o=v):C===e&&(o=Math.max(o,v)),f>h?(f=h,S=m):f===h&&(S=Math.min(S,m)),C>f||C===f&&o>S?null:new M(C,o,f,S)}equalsRange(c){return M.equalsRange(this,c)}static equalsRange(c,p){return!c&&!p?!0:!!c&&!!p&&c.startLineNumber===p.startLineNumber&&c.startColumn===p.startColumn&&c.endLineNumber===p.endLineNumber&&c.endColumn===p.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(c){return new A.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(c){return new A.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,p){return new M(this.startLineNumber,this.startColumn,c,p)}setStartPosition(c,p){return new M(c,p,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(c){return new M(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(c){return new M(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new M(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,p=c){return new M(c.lineNumber,c.column,p.lineNumber,p.column)}static lift(c){return c?new M(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,p){return!(c.endLineNumber<p.startLineNumber||c.endLineNumber===p.startLineNumber&&c.endColumn<p.startColumn||p.endLineNumber<c.startLineNumber||p.endLineNumber===c.startLineNumber&&p.endColumn<c.startColumn)}static areIntersecting(c,p){return!(c.endLineNumber<p.startLineNumber||c.endLineNumber===p.startLineNumber&&c.endColumn<=p.startColumn||p.endLineNumber<c.startLineNumber||p.endLineNumber===c.startLineNumber&&p.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,p){if(c&&p){const f=c.startLineNumber|0,S=p.startLineNumber|0;if(f===S){const e=c.startColumn|0,v=p.startColumn|0;if(e===v){const h=c.endLineNumber|0,m=p.endLineNumber|0;if(h===m){const w=c.endColumn|0,y=p.endColumn|0;return w-y}return h-m}return e-v}return f-S}return(c?1:0)-(p?1:0)}static compareRangesUsingEnds(c,p){return c.endLineNumber===p.endLineNumber?c.endColumn===p.endColumn?c.startLineNumber===p.startLineNumber?c.startColumn-p.startColumn:c.startLineNumber-p.startLineNumber:c.endColumn-p.endColumn:c.endLineNumber-p.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}n.Range=M}),Y(X[31],Q([0,1,3,2]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends M.Range{constructor(p,C,o,f){super(p,C,o,f),this.selectionStartLineNumber=p,this.selectionStartColumn=C,this.positionLineNumber=o,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return i.selectionsEqual(this,p)}static selectionsEqual(p,C){return p.selectionStartLineNumber===C.selectionStartLineNumber&&p.selectionStartColumn===C.selectionStartColumn&&p.positionLineNumber===C.positionLineNumber&&p.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,C){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,p,C):new i(p,C,this.startLineNumber,this.startColumn)}getPosition(){return new A.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new A.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,C){return this.getDirection()===0?new i(p,C,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,p,C)}static fromPositions(p,C=p){return new i(p.lineNumber,p.column,C.lineNumber,C.column)}static fromRange(p,C){return C===0?new i(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new i(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new i(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,C){if(p&&!C||!p&&C)return!1;if(!p&&!C)return!0;if(p.length!==C.length)return!1;for(let o=0,f=p.length;o<f;o++)if(!this.selectionsEqual(p[o],C[o]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,C,o,f,S){return S===0?new i(p,C,o,f):new i(o,f,p,C)}}n.Selection=i}),Y(X[32],Q([0,1,18]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends A.CharacterClassifier{constructor(p){super(0);for(let C=0,o=p.length;C<o;C++)this.set(p.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function i(c){const p={};return C=>(p.hasOwnProperty(C)||(p[C]=c(C)),p[C])}n.getMapForWordSeparators=i(c=>new M(c))}),Y(X[19],Q([0,1,13,14]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(f=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)f.indexOf(e)>=0||(S+="\\"+e);return S+="\\s]+)",new RegExp(S,"g")}n.DEFAULT_WORD_REGEXP=i();function c(f){let S=n.DEFAULT_WORD_REGEXP;if(f&&f instanceof RegExp)if(f.global)S=f;else{let e="g";f.ignoreCase&&(e+="i"),f.multiline&&(e+="m"),f.unicode&&(e+="u"),S=new RegExp(f.source,e)}return S.lastIndex=0,S}n.ensureValidWordDefinition=c;const p=new M.LinkedList;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function C(f,S,e,v,h){if(h||(h=A.Iterable.first(p)),e.length>h.maxLen){let g=f-h.maxLen/2;return g<0?g=0:v+=g,e=e.substring(g,f+h.maxLen/2),C(f,S,e,v,h)}const m=Date.now(),w=f-1-v;let y=-1,_=null;for(let g=1;!(Date.now()-m>=h.timeBudget);g++){const L=w-h.windowSize*g;S.lastIndex=Math.max(0,L);const l=o(S,e,w,y);if(!l&&_||(_=l,L<=0))break;y=L}if(_){const g={word:_[0],startColumn:v+1+_.index,endColumn:v+1+_.index+_[0].length};return S.lastIndex=0,g}return null}n.getWordAtText=C;function o(f,S,e,v){let h;for(;h=f.exec(S);){const m=h.index||0;if(m<=e&&f.lastIndex>=e)return h;if(v>0&&m>v)return null}return null}}),Y(X[6],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=n.SequenceDiff=void 0;class A{constructor(c,p){this.seq1Range=c,this.seq2Range=p}reverse(){return new A(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}n.SequenceDiff=A;class M{constructor(c,p){this.start=c,this.endExclusive=p}get isEmpty(){return this.start===this.endExclusive}delta(c){return new M(this.start+c,this.endExclusive+c)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(c){return new M(Math.min(this.start,c.start),Math.max(this.endExclusive,c.endExclusive))}}n.OffsetRange=M}),Y(X[33],Q([0,1,6]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function M(o,f,S){let e=S;return e=c(o,f,e),e=p(o,f,e),e}n.optimizeSequenceDiffs=M;function i(o,f,S){const e=[];for(const v of S){const h=e[e.length-1];if(!h){e.push(v);continue}v.seq1Range.start-h.seq1Range.endExclusive<=2||v.seq2Range.start-h.seq2Range.endExclusive<=2?e[e.length-1]=new A.SequenceDiff(h.seq1Range.join(v.seq1Range),h.seq2Range.join(v.seq2Range)):e.push(v)}return e}n.smoothenSequenceDiffs=i;function c(o,f,S){const e=[];S.length>0&&e.push(S[0]);for(let v=1;v<S.length;v++){const h=e[e.length-1],m=S[v];if(m.seq1Range.isEmpty){let w=!0;const y=m.seq1Range.start-h.seq1Range.endExclusive;for(let _=1;_<=y;_++)if(f.getElement(m.seq2Range.start-_)!==f.getElement(m.seq2Range.endExclusive-_)){w=!1;break}if(w){e[e.length-1]=new A.SequenceDiff(h.seq1Range,new A.OffsetRange(h.seq2Range.start,m.seq2Range.endExclusive-y));continue}}e.push(m)}return e}n.joinSequenceDiffs=c;function p(o,f,S){if(!o.getBoundaryScore||!f.getBoundaryScore)return S;for(let e=0;e<S.length;e++){const v=S[e];if(v.seq1Range.isEmpty){const h=e>0?S[e-1].seq2Range.endExclusive:-1,m=e+1<S.length?S[e+1].seq2Range.start:f.length;S[e]=C(v,o,f,m,h)}else if(v.seq2Range.isEmpty){const h=e>0?S[e-1].seq1Range.endExclusive:-1,m=e+1<S.length?S[e+1].seq1Range.start:o.length;S[e]=C(v.reverse(),f,o,m,h).reverse()}}return S}n.shiftSequenceDiffs=p;function C(o,f,S,e,v){let m=1;for(;o.seq2Range.start-m>v&&S.getElement(o.seq2Range.start-m)===S.getElement(o.seq2Range.endExclusive-m)&&m<20;)m++;m--;let w=0;for(;o.seq2Range.start+w<e&&S.getElement(o.seq2Range.start+w)===S.getElement(o.seq2Range.endExclusive+w)&&w<20;)w++;if(m===0&&w===0)return o;let y=0,_=-1;for(let g=-m;g<=w;g++){const L=o.seq2Range.start+g,l=o.seq2Range.endExclusive+g,d=o.seq1Range.start+g,s=f.getBoundaryScore(d)+S.getBoundaryScore(L)+S.getBoundaryScore(l);s>_&&(_=s,y=g)}return y!==0?new A.SequenceDiff(o.seq1Range.delta(y),o.seq2Range.delta(y)):o}}),Y(X[34],Q([0,1,6]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class M{compute(o,f){if(o.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,0),new A.OffsetRange(0,f.length))];if(f.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,o.length),new A.OffsetRange(0,0))];function S(L,l){for(;L<o.length&&l<f.length&&o.getElement(L)===f.getElement(l);)L++,l++;return L}let e=0;const v=new c;v.set(0,S(0,0));const h=new p;h.set(0,v.get(0)===0?null:new i(null,0,0,v.get(0)));let m=0;e:for(;;)for(e++,m=-e;m<=e;m+=2){const L=m===e?-1:v.get(m+1),l=m===-e?-1:v.get(m-1)+1,d=Math.min(Math.max(L,l),o.length),s=d-m,a=S(d,s);v.set(m,a);const r=d===L?h.get(m+1):h.get(m-1);if(h.set(m,a!==d?new i(r,d,s,a-d):r),v.get(m)===o.length&&v.get(m)-m===f.length)break e}let w=h.get(m);const y=[];let _=o.length,g=f.length;for(;;){const L=w?w.x+w.length:0,l=w?w.y+w.length:0;if((L!==_||l!==g)&&y.push(new A.SequenceDiff(new A.OffsetRange(L,_),new A.OffsetRange(l,g))),!w)break;_=w.x,g=w.y,w=w.prev}return y.reverse(),y}}n.MyersDiffAlgorithm=M;class i{constructor(o,f,S,e){this.prev=o,this.x=f,this.y=S,this.length=e}}class c{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,f){if(o<0){if(o=-o-1,o>=this.b.length){const S=this.b;this.b=new Int32Array(S.length*2),this.b.set(S)}this.b[o]=f}else{if(o>=this.a.length){const S=this.a;this.a=new Int32Array(S.length*2),this.a.set(S)}this.a[o]=f}}}class p{constructor(){this.a=[],this.b=[]}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,f){o<0?(o=-o-1,this.b[o]=f):this.a[o]=f}}}),Y(X[35],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class A{constructor(i,c){this.width=i,this.height=c,this.a=[],this.a=new Array(i*c)}get(i,c){return this.a[i+c*this.width]}set(i,c,p){this.a[i+c*this.width]=p}}n.Array2D=A}),Y(X[36],Q([0,1,6,35]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class i{compute(p,C,o){const f=new M.Array2D(p.length,C.length),S=new M.Array2D(p.length,C.length),e=new M.Array2D(p.length,C.length);for(let g=0;g<p.length;g++)for(let L=0;L<C.length;L++){const l=g===0?0:f.get(g-1,L),d=L===0?0:f.get(g,L-1);let s;p.getElement(g)===C.getElement(L)?(g===0||L===0?s=0:s=f.get(g-1,L-1),g>0&&L>0&&S.get(g-1,L-1)===3&&(s+=e.get(g-1,L-1)),s+=o?o(g,L):1):s=-1;const a=Math.max(l,d,s);if(a===s){const r=g>0&&L>0?e.get(g-1,L-1):0;e.set(g,L,r+1),S.set(g,L,3)}else a===l?(e.set(g,L,0),S.set(g,L,1)):a===d&&(e.set(g,L,0),S.set(g,L,2));f.set(g,L,a)}const v=[];let h=p.length,m=C.length;function w(g,L){(g+1!==h||L+1!==m)&&v.push(new A.SequenceDiff(new A.OffsetRange(g+1,h),new A.OffsetRange(L+1,m))),h=g,m=L}let y=p.length-1,_=C.length-1;for(;y>=0&&_>=0;)S.get(y,_)===3?(w(y,_),y--,_--):S.get(y,_)===1?y--:_--;return w(-1,-1),v.reverse(),v}}n.DynamicProgrammingDiffing=i}),Y(X[20],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=n.RangeMapping=n.LineRangeMapping=void 0;class A{constructor(p,C,o){this.originalRange=p,this.modifiedRange=C,this.innerChanges=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=A;class M{constructor(p,C){this.originalRange=p,this.modifiedRange=C}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=M;class i{constructor(p,C){this.startLineNumber=p,this.endLineNumberExclusive=C}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(p){return new i(this.startLineNumber+p,this.endLineNumberExclusive+p)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(p){return new i(Math.min(this.startLineNumber,p.startLineNumber),Math.max(this.endLineNumberExclusive,p.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}n.LineRange=i}),Y(X[37],Q([0,1,15,20,4,2,9]),function(U,n,A,M,i,c,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const C=3;class o{computeDiff(l,d,s){var a;const u=new w(l,d,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),b=[];let N=null;for(const R of u.changes){let E;R.originalEndLineNumber===0?E=new M.LineRange(R.originalStartLineNumber+1,R.originalStartLineNumber+1):E=new M.LineRange(R.originalStartLineNumber,R.originalEndLineNumber+1);let P;R.modifiedEndLineNumber===0?P=new M.LineRange(R.modifiedStartLineNumber+1,R.modifiedStartLineNumber+1):P=new M.LineRange(R.modifiedStartLineNumber,R.modifiedEndLineNumber+1);let F=new M.LineRangeMapping(E,P,(a=R.charChanges)===null||a===void 0?void 0:a.map(x=>new M.RangeMapping(new c.Range(x.originalStartLineNumber,x.originalStartColumn,x.originalEndLineNumber,x.originalEndColumn),new c.Range(x.modifiedStartLineNumber,x.modifiedStartColumn,x.modifiedEndLineNumber,x.modifiedEndColumn))));N&&(N.modifiedRange.endLineNumberExclusive===F.modifiedRange.startLineNumber||N.originalRange.endLineNumberExclusive===F.originalRange.startLineNumber)&&(F=new M.LineRangeMapping(N.originalRange.join(F.originalRange),N.modifiedRange.join(F.modifiedRange),N.innerChanges&&F.innerChanges?N.innerChanges.concat(F.innerChanges):void 0),b.pop()),b.push(F),N=F}return(0,p.assertFn)(()=>(0,p.checkAdjacentItems)(b,(R,E)=>E.originalRange.startLineNumber-R.originalRange.endLineNumberExclusive===E.modifiedRange.startLineNumber-R.modifiedRange.endLineNumberExclusive&&R.originalRange.endLineNumberExclusive<E.originalRange.startLineNumber&&R.modifiedRange.endLineNumberExclusive<E.modifiedRange.startLineNumber)),{quitEarly:u.quitEarly,changes:b}}}n.SmartLinesDiffComputer=o;function f(L,l,d,s){return new A.LcsDiff(L,l,d).ComputeDiff(s)}class S{constructor(l){const d=[],s=[];for(let a=0,r=l.length;a<r;a++)d[a]=y(l[a],1),s[a]=_(l[a],1);this.lines=l,this.a=d,this.b=s}getElements(){const l=[];for(let d=0,s=this.lines.length;d<s;d++)l[d]=this.lines[d].substring(this.a[d]-1,this.b[d]-1);return l}getStrictElement(l){return this.lines[l]}getStartLineNumber(l){return l+1}getEndLineNumber(l){return l+1}createCharSequence(l,d,s){const a=[],r=[],u=[];let b=0;for(let N=d;N<=s;N++){const R=this.lines[N],E=l?this.a[N]:1,P=l?this.b[N]:R.length+1;for(let F=E;F<P;F++)a[b]=R.charCodeAt(F-1),r[b]=N+1,u[b]=F,b++;!l&&N<s&&(a[b]=10,r[b]=N+1,u[b]=R.length+1,b++)}return new e(a,r,u)}}class e{constructor(l,d,s){this.a=l,this.b=d,this.d=s}toString(){return"["+this.a.map((l,d)=>(l===10?"\\n":String.fromCharCode(l))+`-(${this.b[d]},${this.d[d]})`).join(", ")+"]"}e(l,d){if(l<0||l>=d.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(l){return l>0&&l===this.b.length?this.getEndLineNumber(l-1):(this.e(l,this.b),this.b[l])}getEndLineNumber(l){return l===-1?this.getStartLineNumber(l+1):(this.e(l,this.b),this.a[l]===10?this.b[l]+1:this.b[l])}getStartColumn(l){return l>0&&l===this.d.length?this.getEndColumn(l-1):(this.e(l,this.d),this.d[l])}getEndColumn(l){return l===-1?this.getStartColumn(l+1):(this.e(l,this.d),this.a[l]===10?1:this.d[l]+1)}}class v{constructor(l,d,s,a,r,u,b,N){this.originalStartLineNumber=l,this.originalStartColumn=d,this.originalEndLineNumber=s,this.originalEndColumn=a,this.modifiedStartLineNumber=r,this.modifiedStartColumn=u,this.modifiedEndLineNumber=b,this.modifiedEndColumn=N}static createFromDiffChange(l,d,s){const a=d.getStartLineNumber(l.originalStart),r=d.getStartColumn(l.originalStart),u=d.getEndLineNumber(l.originalStart+l.originalLength-1),b=d.getEndColumn(l.originalStart+l.originalLength-1),N=s.getStartLineNumber(l.modifiedStart),R=s.getStartColumn(l.modifiedStart),E=s.getEndLineNumber(l.modifiedStart+l.modifiedLength-1),P=s.getEndColumn(l.modifiedStart+l.modifiedLength-1);return new v(a,r,u,b,N,R,E,P)}}function h(L){if(L.length<=1)return L;const l=[L[0]];let d=l[0];for(let s=1,a=L.length;s<a;s++){const r=L[s],u=r.originalStart-(d.originalStart+d.originalLength),b=r.modifiedStart-(d.modifiedStart+d.modifiedLength);Math.min(u,b)<C?(d.originalLength=r.originalStart+r.originalLength-d.originalStart,d.modifiedLength=r.modifiedStart+r.modifiedLength-d.modifiedStart):(l.push(r),d=r)}return l}class m{constructor(l,d,s,a,r){this.originalStartLineNumber=l,this.originalEndLineNumber=d,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=a,this.charChanges=r}static createFromDiffResult(l,d,s,a,r,u,b){let N,R,E,P,F;if(d.originalLength===0?(N=s.getStartLineNumber(d.originalStart)-1,R=0):(N=s.getStartLineNumber(d.originalStart),R=s.getEndLineNumber(d.originalStart+d.originalLength-1)),d.modifiedLength===0?(E=a.getStartLineNumber(d.modifiedStart)-1,P=0):(E=a.getStartLineNumber(d.modifiedStart),P=a.getEndLineNumber(d.modifiedStart+d.modifiedLength-1)),u&&d.originalLength>0&&d.originalLength<20&&d.modifiedLength>0&&d.modifiedLength<20&&r()){const x=s.createCharSequence(l,d.originalStart,d.originalStart+d.originalLength-1),O=a.createCharSequence(l,d.modifiedStart,d.modifiedStart+d.modifiedLength-1);if(x.getElements().length>0&&O.getElements().length>0){let q=f(x,O,r,!0).changes;b&&(q=h(q)),F=[];for(let k=0,I=q.length;k<I;k++)F.push(v.createFromDiffChange(q[k],x,O))}}return new m(N,R,E,P,F)}}class w{constructor(l,d,s){this.a=s.shouldComputeCharChanges,this.b=s.shouldPostProcessCharChanges,this.d=s.shouldIgnoreTrimWhitespace,this.e=s.shouldMakePrettyDiff,this.f=l,this.g=d,this.h=new S(l),this.j=new S(d),this.k=g(s.maxComputationTime),this.l=g(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const l=f(this.h,this.j,this.k,this.e),d=l.changes,s=l.quitEarly;if(this.d){const b=[];for(let N=0,R=d.length;N<R;N++)b.push(m.createFromDiffResult(this.d,d[N],this.h,this.j,this.l,this.a,this.b));return{quitEarly:s,changes:b}}const a=[];let r=0,u=0;for(let b=-1,N=d.length;b<N;b++){const R=b+1<N?d[b+1]:null,E=R?R.originalStart:this.f.length,P=R?R.modifiedStart:this.g.length;for(;r<E&&u<P;){const F=this.f[r],x=this.g[u];if(F!==x){{let O=y(F,1),q=y(x,1);for(;O>1&&q>1;){const k=F.charCodeAt(O-2),I=x.charCodeAt(q-2);if(k!==I)break;O--,q--}(O>1||q>1)&&this.m(a,r+1,1,O,u+1,1,q)}{let O=_(F,1),q=_(x,1);const k=F.length+1,I=x.length+1;for(;O<k&&q<I;){const T=F.charCodeAt(O-1),W=F.charCodeAt(q-1);if(T!==W)break;O++,q++}(O<k||q<I)&&this.m(a,r+1,O,k,u+1,q,I)}}r++,u++}R&&(a.push(m.createFromDiffResult(this.d,R,this.h,this.j,this.l,this.a,this.b)),r+=R.originalLength,u+=R.modifiedLength)}return{quitEarly:s,changes:a}}m(l,d,s,a,r,u,b){if(this.n(l,d,s,a,r,u,b))return;let N;this.a&&(N=[new v(d,s,d,a,r,u,r,b)]),l.push(new m(d,d,r,r,N))}n(l,d,s,a,r,u,b){const N=l.length;if(N===0)return!1;const R=l[N-1];return R.originalEndLineNumber===0||R.modifiedEndLineNumber===0?!1:R.originalEndLineNumber===d&&R.modifiedEndLineNumber===r?(this.a&&R.charChanges&&R.charChanges.push(new v(d,s,d,a,r,u,r,b)),!0):R.originalEndLineNumber+1===d&&R.modifiedEndLineNumber+1===r?(R.originalEndLineNumber=d,R.modifiedEndLineNumber=r,this.a&&R.charChanges&&R.charChanges.push(new v(d,s,d,a,r,u,r,b)),!0):!1}}n.DiffComputer=w;function y(L,l){const d=i.firstNonWhitespaceIndex(L);return d===-1?l:d+1}function _(L,l){const d=i.lastNonWhitespaceIndex(L);return d===-1?l:d+2}function g(L){if(L===0)return()=>!0;const l=Date.now();return()=>Date.now()-l<L}}),Y(X[38],Q([0,1,9,3,2,6,36,33,34,20]),function(U,n,A,M,i,c,p,C,o,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class S{constructor(){this.b=new p.DynamicProgrammingDiffing,this.c=new o.MyersDiffAlgorithm}computeDiff(d,s,a){const r=new Map;function u(I){let T=r.get(I);return T===void 0&&(T=r.size,r.set(I,T)),T}const b=d.map(I=>u(I.trim())),N=s.map(I=>u(I.trim())),R=new h(b,d),E=new h(N,s);let P=(()=>R.length+E.length<1500?this.b.compute(R,E,(I,T)=>d[I]===s[T]?s[T].length===0?.1:1+Math.log(1+s[T].length):.99):this.c.compute(R,E))();P=(0,C.optimizeSequenceDiffs)(R,E,P);const F=[],x=I=>{for(let T=0;T<I;T++){const W=O+T,z=q+T;if(d[W]!==s[z]){const t=this.e(d,s,new c.SequenceDiff(new c.OffsetRange(W,W+1),new c.OffsetRange(z,z+1)));for(const se of t)F.push(se)}}};let O=0,q=0;for(const I of P){(0,A.assertFn)(()=>I.seq1Range.start-O===I.seq2Range.start-q);const T=I.seq1Range.start-O;x(T),O=I.seq1Range.endExclusive,q=I.seq2Range.endExclusive;const W=this.e(d,s,I);for(const z of W)F.push(z)}x(d.length-O);const k=e(F);return{quitEarly:!1,changes:k}}e(d,s,a){const r=new w(d,a.seq1Range),u=new w(s,a.seq2Range),b=r.length+u.length<500?this.b.compute(r,u):this.c.compute(r,u);let N=(0,C.optimizeSequenceDiffs)(r,u,b);return N=(0,C.smoothenSequenceDiffs)(r,u,N),N.map(E=>new f.RangeMapping(r.translateRange(E.seq1Range).delta(a.seq1Range.start),u.translateRange(E.seq2Range).delta(a.seq2Range.start)))}}n.StandardLinesDiffComputer=S;function e(l){const d=[];for(const s of v(l,(a,r)=>r.originalRange.startLineNumber-(a.originalRange.endLineNumber-(a.originalRange.endColumn>1?0:1))<=1||r.modifiedRange.startLineNumber-(a.modifiedRange.endLineNumber-(a.modifiedRange.endColumn>1?0:1))<=1)){const a=s[0],r=s[s.length-1];d.push(new f.LineRangeMapping(new f.LineRange(a.originalRange.startLineNumber,r.originalRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),new f.LineRange(a.modifiedRange.startLineNumber,r.modifiedRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),s))}return(0,A.assertFn)(()=>(0,A.checkAdjacentItems)(d,(s,a)=>a.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===a.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<a.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<a.modifiedRange.startLineNumber)),d}n.lineRangeMappingFromRangeMappings=e;function*v(l,d){let s,a;for(const r of l)a!==void 0&&d(a,r)?s.push(r):(s&&(yield s),s=[r]),a=r;s&&(yield s)}class h{constructor(d,s){this.b=d,this.c=s}getElement(d){return this.b[d]}get length(){return this.b.length}getBoundaryScore(d){const s=d===0?0:m(this.c[d-1]),a=d===this.c.length?0:m(this.c[d]);return 1e3-(s+a)}}n.LineSequence=h;function m(l){let d=0;for(;d<l.length&&(l.charCodeAt(d)===32||l.charCodeAt(d)===9);)d++;return d}class w{constructor(d,s){this.lines=d,this.lineRange=s;let a=0;this.c=new Int32Array(s.length);for(let u=s.start;u<s.endExclusive;u++)a+=d[u].length,this.c[u-s.start]=a+1,a++;this.b=new Int32Array(a);let r=0;for(let u=s.start;u<s.endExclusive;u++){const b=d[u];for(let N=0;N<b.length;N++)this.b[r+N]=b.charCodeAt(N);r+=b.length,u<d.length-1&&(this.b[r]=`
`.charCodeAt(0),r+=1)}}getElement(d){return this.b[d]}get length(){return this.b.length}getBoundaryScore(d){const s=g(d>0?this.b[d-1]:-1),a=g(d<this.b.length?this.b[d]:-1);if(s===6&&a===7)return 0;let r=0;return s!==a&&(r+=10,a===1&&(r+=1)),r+=_(s),r+=_(a),r}translateOffset(d){let s=0,a=this.c.length;for(;s<a;){const u=Math.floor((s+a)/2);this.c[u]>d?a=u:s=u+1}const r=s===0?0:this.c[s-1];return new M.Position(s+1,d-r+1)}translateRange(d){return i.Range.fromPositions(this.translateOffset(d.start),this.translateOffset(d.endExclusive))}}const y={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function _(l){return y[l]}function g(l){return l===10?7:l===13?6:L(l)?5:l>=97&&l<=122?0:l>=65&&l<=90?1:l>=48&&l<=57?2:l===-1?3:4}function L(l){return l===32||l===9}}),Y(X[39],Q([0,1,37,38]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new A.SmartLinesDiffComputer,experimental:new M.StandardLinesDiffComputer}}),Y(X[40],Q([0,1,18]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class M{constructor(v,h,m){const w=new Uint8Array(v*h);for(let y=0,_=v*h;y<_;y++)w[y]=m;this.a=w,this.rows=v,this.cols=h}get(v,h){return this.a[v*this.cols+h]}set(v,h,m){this.a[v*this.cols+h]=m}}class i{constructor(v){let h=0,m=0;for(let y=0,_=v.length;y<_;y++){const[g,L,l]=v[y];L>h&&(h=L),g>m&&(m=g),l>m&&(m=l)}h++,m++;const w=new M(m,h,0);for(let y=0,_=v.length;y<_;y++){const[g,L,l]=v[y];w.set(g,L,l)}this.a=w,this.b=h}nextState(v,h){return h<0||h>=this.b?0:this.a.get(v,h)}}n.StateMachine=i;let c=null;function p(){return c===null&&(c=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),c}let C=null;function o(){if(C===null){C=new A.CharacterClassifier(0);const e=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<e.length;h++)C.set(e.charCodeAt(h),1);const v=".;:";for(let h=0;h<v.length;h++)C.set(v.charCodeAt(h),2)}return C}class f{static a(v,h,m,w,y){let _=y-1;do{const g=h.charCodeAt(_);if(v.get(g)!==2)break;_--}while(_>w);if(w>0){const g=h.charCodeAt(w-1),L=h.charCodeAt(_);(g===40&&L===41||g===91&&L===93||g===123&&L===125)&&_--}return{range:{startLineNumber:m,startColumn:w+1,endLineNumber:m,endColumn:_+2},url:h.substring(w,_+1)}}static computeLinks(v,h=p()){const m=o(),w=[];for(let y=1,_=v.getLineCount();y<=_;y++){const g=v.getLineContent(y),L=g.length;let l=0,d=0,s=0,a=1,r=!1,u=!1,b=!1,N=!1;for(;l<L;){let R=!1;const E=g.charCodeAt(l);if(a===13){let P;switch(E){case 40:r=!0,P=0;break;case 41:P=r?0:1;break;case 91:b=!0,u=!0,P=0;break;case 93:b=!1,P=u?0:1;break;case 123:N=!0,P=0;break;case 125:P=N?0:1;break;case 39:case 34:case 96:s===E?P=1:s===39||s===34||s===96?P=0:P=1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=b?0:1;break;default:P=m.get(E)}P===1&&(w.push(f.a(m,g,y,d,l)),R=!0)}else if(a===12){let P;E===91?(u=!0,P=0):P=m.get(E),P===1?R=!0:a=13}else a=h.nextState(a,E),a===0&&(R=!0);R&&(a=1,r=!1,u=!1,N=!1,d=l+1,s=E),l++}a===13&&w.push(f.a(m,g,y,d,L))}return w}}n.LinkComputer=f;function S(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:f.computeLinks(e)}n.computeLinks=S}),Y(X[41],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class A{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,c,p,C,o){if(i&&c){const f=this.a(c,o);if(f)return{range:i,value:f}}if(p&&C){const f=this.a(C,o);if(f)return{range:p,value:f}}return null}a(i,c){const p=this.b(i,c);return p!==null?p:this.d(i,c)}b(i,c){const p=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let C=Number(i);const o=parseFloat(i);return!isNaN(C)&&!isNaN(o)&&C===o?C===0&&!c?null:(C=Math.floor(C*p),C+=c?p:-p,String(C/p)):null}d(i,c){return this.e(this.c,i,c)}e(i,c,p){let C=null;for(let o=0,f=i.length;C===null&&o<f;o++)C=this.f(i[o],c,p);return C}f(i,c,p){let C=i.indexOf(c);return C>=0?(C+=p?1:-1,C<0?C=i.length-1:C%=i.length,i[C]):null}}n.BasicInplaceReplace=A,A.INSTANCE=new A}),Y(X[42],Q([0,1,11]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var M;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(M=n.OverviewRulerLane||(n.OverviewRulerLane={}));var i;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(i=n.MinimapPosition||(n.MinimapPosition={}));var c;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(c=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));class p{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,m.indentSize|0),this.a=!1),this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.a===m.a&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,A.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}n.TextModelResolvedOptions=p;class C{constructor(m,w){this._findMatchBrand=void 0,this.range=m,this.matches=w}}n.FindMatch=C;function o(h){return h&&typeof h.read=="function"}n.isITextSnapshot=o;class f{constructor(m,w,y,_,g,L){this.identifier=m,this.range=w,this.text=y,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=g,this._isTracked=L}}n.ValidAnnotatedEditOperation=f;class S{constructor(m,w,y){this.regex=m,this.wordSeparators=w,this.simpleSearch=y}}n.SearchData=S;class e{constructor(m,w,y){this.reverseEdits=m,this.changes=w,this.trimAutoWhitespaceLineNumbers=y}}n.ApplyEditsResult=e;function v(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}n.shouldSynchronizeModel=v}),Y(X[43],Q([0,1,23,17]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(o){this.a=o,this.b=new Uint32Array(o.length),this.c=new Int32Array(1),this.c[0]=-1}insertValues(o,f){o=(0,M.toUint32)(o);const S=this.a,e=this.b,v=f.length;return v===0?!1:(this.a=new Uint32Array(S.length+v),this.a.set(S.subarray(0,o),0),this.a.set(S.subarray(o),o+v),this.a.set(f,o),o-1<this.c[0]&&(this.c[0]=o-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(e.subarray(0,this.c[0]+1)),!0)}setValue(o,f){return o=(0,M.toUint32)(o),f=(0,M.toUint32)(f),this.a[o]===f?!1:(this.a[o]=f,o-1<this.c[0]&&(this.c[0]=o-1),!0)}removeValues(o,f){o=(0,M.toUint32)(o),f=(0,M.toUint32)(f);const S=this.a,e=this.b;if(o>=S.length)return!1;const v=S.length-o;return f>=v&&(f=v),f===0?!1:(this.a=new Uint32Array(S.length-f),this.a.set(S.subarray(0,o),0),this.a.set(S.subarray(o+f),o),this.b=new Uint32Array(this.a.length),o-1<this.c[0]&&(this.c[0]=o-1),this.c[0]>=0&&this.b.set(e.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(o){return o<0?0:(o=(0,M.toUint32)(o),this.d(o))}d(o){if(o<=this.c[0])return this.b[o];let f=this.c[0]+1;f===0&&(this.b[0]=this.a[0],f++),o>=this.a.length&&(o=this.a.length-1);for(let S=f;S<=o;S++)this.b[S]=this.b[S-1]+this.a[S];return this.c[0]=Math.max(this.c[0],o),this.b[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let f=0,S=this.a.length-1,e=0,v=0,h=0;for(;f<=S;)if(e=f+(S-f)/2|0,v=this.b[e],h=v-this.a[e],o<h)S=e-1;else if(o>=v)f=e+1;else break;return new p(e,o-h)}}n.PrefixSumComputer=i;class c{constructor(o){this.a=o,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(o){return this.g(),o===0?0:this.d[o-1]}getIndexOf(o){this.g();const f=this.e[o],S=f>0?this.d[f-1]:0;return new p(f,o-S)}removeValues(o,f){this.a.splice(o,f),this.f(o)}insertValues(o,f){this.a=(0,A.arrayInsert)(this.a,o,f),this.f(o)}f(o){this.b=!1,this.c=Math.min(this.c,o-1)}g(){if(!this.b){for(let o=this.c+1,f=this.a.length;o<f;o++){const S=this.a[o],e=o>0?this.d[o-1]:0;this.d[o]=e+S;for(let v=0;v<S;v++)this.e[e+v]=o}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(o,f){this.a[o]!==f&&(this.a[o]=f,this.f(o))}}n.ConstantTimePrefixSumComputer=c;class p{constructor(o,f){this.index=o,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=f}}n.PrefixSumIndexOfResult=p}),Y(X[44],Q([0,1,4,3,43]),function(U,n,A,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class c{constructor(C,o,f,S){this.c=C,this.d=o,this.f=f,this.g=S,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(C){C.eol&&C.eol!==this.f&&(this.f=C.eol,this.h=null);const o=C.changes;for(const f of o)this.n(f.range),this.o(new M.Position(f.range.startLineNumber,f.range.startColumn),f.text);this.g=C.versionId,this.j=null}k(){if(!this.h){const C=this.f.length,o=this.d.length,f=new Uint32Array(o);for(let S=0;S<o;S++)f[S]=this.d[S].length+C;this.h=new i.PrefixSumComputer(f)}}l(C,o){this.d[C]=o,this.h&&this.h.setValue(C,this.d[C].length+this.f.length)}n(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this.l(C.startLineNumber-1,this.d[C.startLineNumber-1].substring(0,C.startColumn-1)+this.d[C.startLineNumber-1].substring(C.endColumn-1));return}this.l(C.startLineNumber-1,this.d[C.startLineNumber-1].substring(0,C.startColumn-1)+this.d[C.endLineNumber-1].substring(C.endColumn-1)),this.d.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this.h&&this.h.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}o(C,o){if(o.length===0)return;const f=(0,A.splitLines)(o);if(f.length===1){this.l(C.lineNumber-1,this.d[C.lineNumber-1].substring(0,C.column-1)+f[0]+this.d[C.lineNumber-1].substring(C.column-1));return}f[f.length-1]+=this.d[C.lineNumber-1].substring(C.column-1),this.l(C.lineNumber-1,this.d[C.lineNumber-1].substring(0,C.column-1)+f[0]);const S=new Uint32Array(f.length-1);for(let e=1;e<f.length;e++)this.d.splice(C.lineNumber+e-1,0,f[e]),S[e-1]=f[e].length+this.f.length;this.h&&this.h.insertValues(C.lineNumber,S)}}n.MirrorTextModel=c}),Y(X[45],Q([0,1,4,32,3,2,42]),function(U,n,A,M,i,c,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const C=999;class o{constructor(g,L,l,d){this.searchString=g,this.isRegex=L,this.matchCase=l,this.wordSeparators=d}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=f(this.searchString):g=this.searchString.indexOf(`
`)>=0;let L=null;try{L=A.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!L)return null;let l=!this.isRegex&&!g;return l&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(l=this.matchCase),new p.SearchData(L,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,l?this.searchString:null)}}n.SearchParams=o;function f(_){if(!_||_.length===0)return!1;for(let g=0,L=_.length;g<L;g++){const l=_.charCodeAt(g);if(l===10)return!0;if(l===92){if(g++,g>=L)break;const d=_.charCodeAt(g);if(d===110||d===114||d===87)return!0}}return!1}n.isMultilineRegexSource=f;function S(_,g,L){if(!L)return new p.FindMatch(_,null);const l=[];for(let d=0,s=g.length;d<s;d++)l[d]=g[d];return new p.FindMatch(_,l)}n.createFindMatch=S;class e{constructor(g){const L=[];let l=0;for(let d=0,s=g.length;d<s;d++)g.charCodeAt(d)===10&&(L[l++]=d);this.a=L}findLineFeedCountBeforeOffset(g){const L=this.a;let l=0,d=L.length-1;if(d===-1||g<=L[0])return 0;for(;l<d;){const s=l+((d-l)/2>>0);L[s]>=g?d=s-1:L[s+1]>=g?(l=s,d=s):l=s+1}return l+1}}class v{static findMatches(g,L,l,d,s){const a=L.parseSearchRequest();return a?a.regex.multiline?this.b(g,l,new y(a.wordSeparators,a.regex),d,s):this.c(g,l,a,d,s):[]}static a(g,L,l,d,s,a){let r,u=0;d?(u=d.findLineFeedCountBeforeOffset(s),r=L+s+u):r=L+s;let b;if(d){const P=d.findLineFeedCountBeforeOffset(s+a.length)-u;b=r+a.length+P}else b=r+a.length;const N=g.getPositionAt(r),R=g.getPositionAt(b);return new c.Range(N.lineNumber,N.column,R.lineNumber,R.column)}static b(g,L,l,d,s){const a=g.getOffsetAt(L.getStartPosition()),r=g.getValueInRange(L,1),u=g.getEOL()===`\r
`?new e(r):null,b=[];let N=0,R;for(l.reset(0);R=l.next(r);)if(b[N++]=S(this.a(g,a,r,u,R.index,R[0]),R,d),N>=s)return b;return b}static c(g,L,l,d,s){const a=[];let r=0;if(L.startLineNumber===L.endLineNumber){const b=g.getLineContent(L.startLineNumber).substring(L.startColumn-1,L.endColumn-1);return r=this.d(l,b,L.startLineNumber,L.startColumn-1,r,a,d,s),a}const u=g.getLineContent(L.startLineNumber).substring(L.startColumn-1);r=this.d(l,u,L.startLineNumber,L.startColumn-1,r,a,d,s);for(let b=L.startLineNumber+1;b<L.endLineNumber&&r<s;b++)r=this.d(l,g.getLineContent(b),b,0,r,a,d,s);if(r<s){const b=g.getLineContent(L.endLineNumber).substring(0,L.endColumn-1);r=this.d(l,b,L.endLineNumber,0,r,a,d,s)}return a}static d(g,L,l,d,s,a,r,u){const b=g.wordSeparators;if(!r&&g.simpleSearch){const E=g.simpleSearch,P=E.length,F=L.length;let x=-P;for(;(x=L.indexOf(E,x+P))!==-1;)if((!b||w(b,L,F,x,P))&&(a[s++]=new p.FindMatch(new c.Range(l,x+1+d,l,x+1+P+d),null),s>=u))return s;return s}const N=new y(g.wordSeparators,g.regex);let R;N.reset(0);do if(R=N.next(L),R&&(a[s++]=S(new c.Range(l,R.index+1+d,l,R.index+1+R[0].length+d),R,r),s>=u))return s;while(R);return s}static findNextMatch(g,L,l,d){const s=L.parseSearchRequest();if(!s)return null;const a=new y(s.wordSeparators,s.regex);return s.regex.multiline?this.e(g,l,a,d):this.f(g,l,a,d)}static e(g,L,l,d){const s=new i.Position(L.lineNumber,1),a=g.getOffsetAt(s),r=g.getLineCount(),u=g.getValueInRange(new c.Range(s.lineNumber,s.column,r,g.getLineMaxColumn(r)),1),b=g.getEOL()===`\r
`?new e(u):null;l.reset(L.column-1);const N=l.next(u);return N?S(this.a(g,a,u,b,N.index,N[0]),N,d):L.lineNumber!==1||L.column!==1?this.e(g,new i.Position(1,1),l,d):null}static f(g,L,l,d){const s=g.getLineCount(),a=L.lineNumber,r=g.getLineContent(a),u=this.g(l,r,a,L.column,d);if(u)return u;for(let b=1;b<=s;b++){const N=(a+b-1)%s,R=g.getLineContent(N+1),E=this.g(l,R,N+1,1,d);if(E)return E}return null}static g(g,L,l,d,s){g.reset(d-1);const a=g.next(L);return a?S(new c.Range(l,a.index+1,l,a.index+1+a[0].length),a,s):null}static findPreviousMatch(g,L,l,d){const s=L.parseSearchRequest();if(!s)return null;const a=new y(s.wordSeparators,s.regex);return s.regex.multiline?this.h(g,l,a,d):this.j(g,l,a,d)}static h(g,L,l,d){const s=this.b(g,new c.Range(1,1,L.lineNumber,L.column),l,d,10*C);if(s.length>0)return s[s.length-1];const a=g.getLineCount();return L.lineNumber!==a||L.column!==g.getLineMaxColumn(a)?this.h(g,new i.Position(a,g.getLineMaxColumn(a)),l,d):null}static j(g,L,l,d){const s=g.getLineCount(),a=L.lineNumber,r=g.getLineContent(a).substring(0,L.column-1),u=this.k(l,r,a,d);if(u)return u;for(let b=1;b<=s;b++){const N=(s+a-b-1)%s,R=g.getLineContent(N+1),E=this.k(l,R,N+1,d);if(E)return E}return null}static k(g,L,l,d){let s=null,a;for(g.reset(0);a=g.next(L);)s=S(new c.Range(l,a.index+1,l,a.index+1+a[0].length),a,d);return s}}n.TextModelSearch=v;function h(_,g,L,l,d){if(l===0)return!0;const s=g.charCodeAt(l-1);if(_.get(s)!==0||s===13||s===10)return!0;if(d>0){const a=g.charCodeAt(l);if(_.get(a)!==0)return!0}return!1}function m(_,g,L,l,d){if(l+d===L)return!0;const s=g.charCodeAt(l+d);if(_.get(s)!==0||s===13||s===10)return!0;if(d>0){const a=g.charCodeAt(l+d-1);if(_.get(a)!==0)return!0}return!1}function w(_,g,L,l,d){return h(_,g,L,l,d)&&m(_,g,L,l,d)}n.isValidMatch=w;class y{constructor(g,L){this._wordSeparators=g,this.a=L,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const L=g.length;let l;do{if(this.b+this.c===L||(l=this.a.exec(g),!l))return null;const d=l.index,s=l[0].length;if(d===this.b&&s===this.c){if(s===0){A.getNextCodePoint(g,L,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=d,this.c=s,!this._wordSeparators||w(this._wordSeparators,g,L,d,s))return l}while(l);return null}}n.Searcher=y}),Y(X[46],Q([0,1,2,45,4,9,19]),function(U,n,A,M,i,c,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class C{static computeUnicodeHighlights(v,h,m){const w=m?m.startLineNumber:1,y=m?m.endLineNumber:v.getLineCount(),_=new f(h),g=_.getCandidateCodePoints();let L;g==="allNonBasicAscii"?L=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):L=new RegExp(`${o(Array.from(g))}`,"g");const l=new M.Searcher(null,L),d=[];let s=!1,a,r=0,u=0,b=0;e:for(let N=w,R=y;N<=R;N++){const E=v.getLineContent(N),P=E.length;l.reset(0);do if(a=l.next(E),a){let F=a.index,x=a.index+a[0].length;if(F>0){const I=E.charCodeAt(F-1);i.isHighSurrogate(I)&&F--}if(x+1<P){const I=E.charCodeAt(x-1);i.isHighSurrogate(I)&&x++}const O=E.substring(F,x);let q=(0,p.getWordAtText)(F+1,p.DEFAULT_WORD_REGEXP,E,0);q&&q.endColumn<=F+1&&(q=null);const k=_.shouldHighlightNonBasicASCII(O,q?q.word:null);if(k!==0){k===3?r++:k===2?u++:k===1?b++:(0,c.assertNever)(k);const I=1e3;if(d.length>=I){s=!0;break e}d.push(new A.Range(N,F+1,N,x+1))}}while(a)}return{ranges:d,hasMore:s,ambiguousCharacterCount:r,invisibleCharacterCount:u,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(v,h){const m=new f(h);switch(m.shouldHighlightNonBasicASCII(v,null)){case 0:return null;case 2:return{kind:1};case 3:{const y=v.codePointAt(0),_=m.ambiguousCharacters.getPrimaryConfusable(y),g=i.AmbiguousCharacters.getLocales().filter(L=>!i.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,L])).isAmbiguous(y));return{kind:0,confusableWith:String.fromCodePoint(_),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=C;function o(e,v){return`[${i.escapeRegExpCharacters(e.map(m=>String.fromCodePoint(m)).join(""))}]`}class f{constructor(v){this.b=v,this.a=new Set(v.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(v.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const v=new Set;if(this.b.invisibleCharacters)for(const h of i.InvisibleCharacters.codePoints)S(String.fromCodePoint(h))||v.add(h);if(this.b.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())v.add(h);for(const h of this.a)v.delete(h);return v}shouldHighlightNonBasicASCII(v,h){const m=v.codePointAt(0);if(this.a.has(m))return 0;if(this.b.nonBasicASCII)return 1;let w=!1,y=!1;if(h)for(const _ of h){const g=_.codePointAt(0),L=i.isBasicASCII(_);w=w||L,!L&&!this.ambiguousCharacters.isAmbiguous(g)&&!i.InvisibleCharacters.isInvisibleCharacter(g)&&(y=!0)}return!w&&y?0:this.b.invisibleCharacters&&!S(v)&&i.InvisibleCharacters.isInvisibleCharacter(m)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(m)?3:0}}function S(e){return e===" "||e===`
`||e==="	"}}),Y(X[47],Q([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var A;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(A=n.AccessibilitySupport||(n.AccessibilitySupport={}));var M;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(M=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var c;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(c=n.CompletionItemKind||(n.CompletionItemKind={}));var p;(function(t){t[t.Deprecated=1]="Deprecated"})(p=n.CompletionItemTag||(n.CompletionItemTag={}));var C;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var o;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(o=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var f;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(f=n.CursorChangeReason||(n.CursorChangeReason={}));var S;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(S=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var v;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(v=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var h;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.colorDecoratorsLimit=18]="colorDecoratorsLimit",t[t.columnSelection=19]="columnSelection",t[t.comments=20]="comments",t[t.contextmenu=21]="contextmenu",t[t.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",t[t.cursorBlinking=23]="cursorBlinking",t[t.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",t[t.cursorStyle=25]="cursorStyle",t[t.cursorSurroundingLines=26]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",t[t.cursorWidth=28]="cursorWidth",t[t.disableLayerHinting=29]="disableLayerHinting",t[t.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",t[t.domReadOnly=31]="domReadOnly",t[t.dragAndDrop=32]="dragAndDrop",t[t.dropIntoEditor=33]="dropIntoEditor",t[t.emptySelectionClipboard=34]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",t[t.extraEditorClassName=36]="extraEditorClassName",t[t.fastScrollSensitivity=37]="fastScrollSensitivity",t[t.find=38]="find",t[t.fixedOverflowWidgets=39]="fixedOverflowWidgets",t[t.folding=40]="folding",t[t.foldingStrategy=41]="foldingStrategy",t[t.foldingHighlight=42]="foldingHighlight",t[t.foldingImportsByDefault=43]="foldingImportsByDefault",t[t.foldingMaximumRegions=44]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=46]="fontFamily",t[t.fontInfo=47]="fontInfo",t[t.fontLigatures=48]="fontLigatures",t[t.fontSize=49]="fontSize",t[t.fontWeight=50]="fontWeight",t[t.fontVariations=51]="fontVariations",t[t.formatOnPaste=52]="formatOnPaste",t[t.formatOnType=53]="formatOnType",t[t.glyphMargin=54]="glyphMargin",t[t.gotoLocation=55]="gotoLocation",t[t.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",t[t.hover=57]="hover",t[t.inDiffEditor=58]="inDiffEditor",t[t.inlineSuggest=59]="inlineSuggest",t[t.letterSpacing=60]="letterSpacing",t[t.lightbulb=61]="lightbulb",t[t.lineDecorationsWidth=62]="lineDecorationsWidth",t[t.lineHeight=63]="lineHeight",t[t.lineNumbers=64]="lineNumbers",t[t.lineNumbersMinChars=65]="lineNumbersMinChars",t[t.linkedEditing=66]="linkedEditing",t[t.links=67]="links",t[t.matchBrackets=68]="matchBrackets",t[t.minimap=69]="minimap",t[t.mouseStyle=70]="mouseStyle",t[t.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=72]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",t[t.multiCursorModifier=74]="multiCursorModifier",t[t.multiCursorPaste=75]="multiCursorPaste",t[t.multiCursorLimit=76]="multiCursorLimit",t[t.occurrencesHighlight=77]="occurrencesHighlight",t[t.overviewRulerBorder=78]="overviewRulerBorder",t[t.overviewRulerLanes=79]="overviewRulerLanes",t[t.padding=80]="padding",t[t.parameterHints=81]="parameterHints",t[t.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",t[t.quickSuggestions=84]="quickSuggestions",t[t.quickSuggestionsDelay=85]="quickSuggestionsDelay",t[t.readOnly=86]="readOnly",t[t.renameOnType=87]="renameOnType",t[t.renderControlCharacters=88]="renderControlCharacters",t[t.renderFinalNewline=89]="renderFinalNewline",t[t.renderLineHighlight=90]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=92]="renderValidationDecorations",t[t.renderWhitespace=93]="renderWhitespace",t[t.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",t[t.roundedSelection=95]="roundedSelection",t[t.rulers=96]="rulers",t[t.scrollbar=97]="scrollbar",t[t.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=99]="scrollBeyondLastLine",t[t.scrollPredominantAxis=100]="scrollPredominantAxis",t[t.selectionClipboard=101]="selectionClipboard",t[t.selectionHighlight=102]="selectionHighlight",t[t.selectOnLineNumbers=103]="selectOnLineNumbers",t[t.showFoldingControls=104]="showFoldingControls",t[t.showUnused=105]="showUnused",t[t.snippetSuggestions=106]="snippetSuggestions",t[t.smartSelect=107]="smartSelect",t[t.smoothScrolling=108]="smoothScrolling",t[t.stickyScroll=109]="stickyScroll",t[t.stickyTabStops=110]="stickyTabStops",t[t.stopRenderingLineAfter=111]="stopRenderingLineAfter",t[t.suggest=112]="suggest",t[t.suggestFontSize=113]="suggestFontSize",t[t.suggestLineHeight=114]="suggestLineHeight",t[t.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",t[t.suggestSelection=116]="suggestSelection",t[t.tabCompletion=117]="tabCompletion",t[t.tabIndex=118]="tabIndex",t[t.unicodeHighlighting=119]="unicodeHighlighting",t[t.unusualLineTerminators=120]="unusualLineTerminators",t[t.useShadowDOM=121]="useShadowDOM",t[t.useTabStops=122]="useTabStops",t[t.wordBreak=123]="wordBreak",t[t.wordSeparators=124]="wordSeparators",t[t.wordWrap=125]="wordWrap",t[t.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=128]="wordWrapColumn",t[t.wordWrapOverride1=129]="wordWrapOverride1",t[t.wordWrapOverride2=130]="wordWrapOverride2",t[t.wrappingIndent=131]="wrappingIndent",t[t.wrappingStrategy=132]="wrappingStrategy",t[t.showDeprecated=133]="showDeprecated",t[t.inlayHints=134]="inlayHints",t[t.editorClassName=135]="editorClassName",t[t.pixelRatio=136]="pixelRatio",t[t.tabFocusMode=137]="tabFocusMode",t[t.layoutInfo=138]="layoutInfo",t[t.wrappingInfo=139]="wrappingInfo"})(h=n.EditorOption||(n.EditorOption={}));var m;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(m=n.EndOfLinePreference||(n.EndOfLinePreference={}));var w;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(w=n.EndOfLineSequence||(n.EndOfLineSequence={}));var y;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(y=n.IndentAction||(n.IndentAction={}));var _;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(_=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var g;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(g=n.InlayHintKind||(n.InlayHintKind={}));var L;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(L=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var l;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(l=n.KeyCode||(n.KeyCode={}));var d;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(d=n.MarkerSeverity||(n.MarkerSeverity={}));var s;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(s=n.MarkerTag||(n.MarkerTag={}));var a;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(a=n.MinimapPosition||(n.MinimapPosition={}));var r;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(r=n.MouseTargetType||(n.MouseTargetType={}));var u;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(u=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var b;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(b=n.OverviewRulerLane||(n.OverviewRulerLane={}));var N;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(N=n.PositionAffinity||(n.PositionAffinity={}));var R;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(R=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var E;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(E=n.RenderMinimap||(n.RenderMinimap={}));var P;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(P=n.ScrollType||(n.ScrollType={}));var F;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(F=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var x;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(x=n.SelectionDirection||(n.SelectionDirection={}));var O;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(O=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var q;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(q=n.SymbolKind||(n.SymbolKind={}));var k;(function(t){t[t.Deprecated=1]="Deprecated"})(k=n.SymbolTag||(n.SymbolTag={}));var I;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(I=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var T;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(T=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var W;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(W=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var z;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(z=n.WrappingIndent||(n.WrappingIndent={}))}),Y(X[48],Q([22,55]),function(U,n){return U.create("vs/base/common/platform",n)}),Y(X[5],Q([0,1,48]),function(U,n,A){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,c=!1,p=!1,C=!1,o=!1,f=!1,S=!1,e=!1,v=!1,h=!1,m,w=n.LANGUAGE_DEFAULT,y,_;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?g=n.globals.vscode.process:typeof process<"u"&&(g=process);const L=typeof((M=g?.versions)===null||M===void 0?void 0:M.electron)=="string",l=L&&g?.type==="renderer";if(typeof navigator=="object"&&!l)_=navigator.userAgent,i=_.indexOf("Windows")>=0,c=_.indexOf("Macintosh")>=0,e=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=_.indexOf("Linux")>=0,h=_?.indexOf("Mobi")>=0,f=!0,m=A.getConfiguredDefaultLocale(A.localize(0,null))||n.LANGUAGE_DEFAULT,w=m;else if(typeof g=="object"){i=g.platform==="win32",c=g.platform==="darwin",p=g.platform==="linux",C=p&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,S=L,v=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=n.LANGUAGE_DEFAULT,w=n.LANGUAGE_DEFAULT;const u=g.env.VSCODE_NLS_CONFIG;if(u)try{const b=JSON.parse(u),N=b.availableLanguages["*"];m=b.locale,w=N||n.LANGUAGE_DEFAULT,y=b._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");let d=0;c?d=1:i?d=3:p&&(d=2),n.isWindows=i,n.isMacintosh=c,n.isLinux=p,n.isNative=o,n.isWeb=f,n.isWebWorker=f&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=h,n.userAgent=_,n.language=w,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const u=[];n.globals.addEventListener("message",N=>{if(N.data&&N.data.vscodeScheduleAsyncWork)for(let R=0,E=u.length;R<E;R++){const P=u[R];if(P.id===N.data.vscodeScheduleAsyncWork){u.splice(R,1),P.callback();return}}});let b=0;return N=>{const R=++b;u.push({id:R,callback:N}),n.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return u=>setTimeout(u)})(),n.OS=c||e?2:i?1:3;let s=!0,a=!1;function r(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,s=new Uint16Array(u.buffer)[0]===(2<<8)+1}return s}n.isLittleEndian=r,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[49],Q([0,1,5]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const i=A.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),Y(X[50],Q([0,1,49]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,i=97,c=90,p=122,C=46,o=47,f=92,S=58,e=63;class v extends Error{constructor(a,r,u){let b;typeof r=="string"&&r.indexOf("not ")===0?(b="must not be",r=r.replace(/^not /,"")):b="must be";const N=a.indexOf(".")!==-1?"property":"argument";let R=`The "${a}" ${N} ${b} of type ${r}`;R+=`. Received type ${typeof u}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function h(s,a){if(s===null||typeof s!="object")throw new v(a,"Object",s)}function m(s,a){if(typeof s!="string")throw new v(a,"string",s)}const w=A.platform==="win32";function y(s){return s===o||s===f}function _(s){return s===o}function g(s){return s>=M&&s<=c||s>=i&&s<=p}function L(s,a,r,u){let b="",N=0,R=-1,E=0,P=0;for(let F=0;F<=s.length;++F){if(F<s.length)P=s.charCodeAt(F);else{if(u(P))break;P=o}if(u(P)){if(!(R===F-1||E===1))if(E===2){if(b.length<2||N!==2||b.charCodeAt(b.length-1)!==C||b.charCodeAt(b.length-2)!==C){if(b.length>2){const x=b.lastIndexOf(r);x===-1?(b="",N=0):(b=b.slice(0,x),N=b.length-1-b.lastIndexOf(r)),R=F,E=0;continue}else if(b.length!==0){b="",N=0,R=F,E=0;continue}}a&&(b+=b.length>0?`${r}..`:"..",N=2)}else b.length>0?b+=`${r}${s.slice(R+1,F)}`:b=s.slice(R+1,F),N=F-R-1;R=F,E=0}else P===C&&E!==-1?++E:E=-1}return b}function l(s,a){h(a,"pathObject");const r=a.dir||a.root,u=a.base||`${a.name||""}${a.ext||""}`;return r?r===a.root?`${r}${u}`:`${r}${s}${u}`:u}n.win32={resolve(...s){let a="",r="",u=!1;for(let b=s.length-1;b>=-1;b--){let N;if(b>=0){if(N=s[b],m(N,"path"),N.length===0)continue}else a.length===0?N=A.cwd():(N=A.env[`=${a}`]||A.cwd(),(N===void 0||N.slice(0,2).toLowerCase()!==a.toLowerCase()&&N.charCodeAt(2)===f)&&(N=`${a}\\`));const R=N.length;let E=0,P="",F=!1;const x=N.charCodeAt(0);if(R===1)y(x)&&(E=1,F=!0);else if(y(x))if(F=!0,y(N.charCodeAt(1))){let O=2,q=O;for(;O<R&&!y(N.charCodeAt(O));)O++;if(O<R&&O!==q){const k=N.slice(q,O);for(q=O;O<R&&y(N.charCodeAt(O));)O++;if(O<R&&O!==q){for(q=O;O<R&&!y(N.charCodeAt(O));)O++;(O===R||O!==q)&&(P=`\\\\${k}\\${N.slice(q,O)}`,E=O)}}}else E=1;else g(x)&&N.charCodeAt(1)===S&&(P=N.slice(0,2),E=2,R>2&&y(N.charCodeAt(2))&&(F=!0,E=3));if(P.length>0)if(a.length>0){if(P.toLowerCase()!==a.toLowerCase())continue}else a=P;if(u){if(a.length>0)break}else if(r=`${N.slice(E)}\\${r}`,u=F,F&&a.length>0)break}return r=L(r,!u,"\\",y),u?`${a}\\${r}`:`${a}${r}`||"."},normalize(s){m(s,"path");const a=s.length;if(a===0)return".";let r=0,u,b=!1;const N=s.charCodeAt(0);if(a===1)return _(N)?"\\":s;if(y(N))if(b=!0,y(s.charCodeAt(1))){let E=2,P=E;for(;E<a&&!y(s.charCodeAt(E));)E++;if(E<a&&E!==P){const F=s.slice(P,E);for(P=E;E<a&&y(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&!y(s.charCodeAt(E));)E++;if(E===a)return`\\\\${F}\\${s.slice(P)}\\`;E!==P&&(u=`\\\\${F}\\${s.slice(P,E)}`,r=E)}}}else r=1;else g(N)&&s.charCodeAt(1)===S&&(u=s.slice(0,2),r=2,a>2&&y(s.charCodeAt(2))&&(b=!0,r=3));let R=r<a?L(s.slice(r),!b,"\\",y):"";return R.length===0&&!b&&(R="."),R.length>0&&y(s.charCodeAt(a-1))&&(R+="\\"),u===void 0?b?`\\${R}`:R:b?`${u}\\${R}`:`${u}${R}`},isAbsolute(s){m(s,"path");const a=s.length;if(a===0)return!1;const r=s.charCodeAt(0);return y(r)||a>2&&g(r)&&s.charCodeAt(1)===S&&y(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,r;for(let N=0;N<s.length;++N){const R=s[N];m(R,"path"),R.length>0&&(a===void 0?a=r=R:a+=`\\${R}`)}if(a===void 0)return".";let u=!0,b=0;if(typeof r=="string"&&y(r.charCodeAt(0))){++b;const N=r.length;N>1&&y(r.charCodeAt(1))&&(++b,N>2&&(y(r.charCodeAt(2))?++b:u=!1))}if(u){for(;b<a.length&&y(a.charCodeAt(b));)b++;b>=2&&(a=`\\${a.slice(b)}`)}return n.win32.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a)return"";const r=n.win32.resolve(s),u=n.win32.resolve(a);if(r===u||(s=r.toLowerCase(),a=u.toLowerCase(),s===a))return"";let b=0;for(;b<s.length&&s.charCodeAt(b)===f;)b++;let N=s.length;for(;N-1>b&&s.charCodeAt(N-1)===f;)N--;const R=N-b;let E=0;for(;E<a.length&&a.charCodeAt(E)===f;)E++;let P=a.length;for(;P-1>E&&a.charCodeAt(P-1)===f;)P--;const F=P-E,x=R<F?R:F;let O=-1,q=0;for(;q<x;q++){const I=s.charCodeAt(b+q);if(I!==a.charCodeAt(E+q))break;I===f&&(O=q)}if(q!==x){if(O===-1)return u}else{if(F>x){if(a.charCodeAt(E+q)===f)return u.slice(E+q+1);if(q===2)return u.slice(E+q)}R>x&&(s.charCodeAt(b+q)===f?O=q:q===2&&(O=3)),O===-1&&(O=0)}let k="";for(q=b+O+1;q<=N;++q)(q===N||s.charCodeAt(q)===f)&&(k+=k.length===0?"..":"\\..");return E+=O,k.length>0?`${k}${u.slice(E,P)}`:(u.charCodeAt(E)===f&&++E,u.slice(E,P))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=n.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const r=a.charCodeAt(2);if(r!==e&&r!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(g(a.charCodeAt(0))&&a.charCodeAt(1)===S&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return s},dirname(s){m(s,"path");const a=s.length;if(a===0)return".";let r=-1,u=0;const b=s.charCodeAt(0);if(a===1)return y(b)?s:".";if(y(b)){if(r=u=1,y(s.charCodeAt(1))){let E=2,P=E;for(;E<a&&!y(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&y(s.charCodeAt(E));)E++;if(E<a&&E!==P){for(P=E;E<a&&!y(s.charCodeAt(E));)E++;if(E===a)return s;E!==P&&(r=u=E+1)}}}}else g(b)&&s.charCodeAt(1)===S&&(r=a>2&&y(s.charCodeAt(2))?3:2,u=r);let N=-1,R=!0;for(let E=a-1;E>=u;--E)if(y(s.charCodeAt(E))){if(!R){N=E;break}}else R=!1;if(N===-1){if(r===-1)return".";N=r}return s.slice(0,N)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let r=0,u=-1,b=!0,N;if(s.length>=2&&g(s.charCodeAt(0))&&s.charCodeAt(1)===S&&(r=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let R=a.length-1,E=-1;for(N=s.length-1;N>=r;--N){const P=s.charCodeAt(N);if(y(P)){if(!b){r=N+1;break}}else E===-1&&(b=!1,E=N+1),R>=0&&(P===a.charCodeAt(R)?--R===-1&&(u=N):(R=-1,u=E))}return r===u?u=E:u===-1&&(u=s.length),s.slice(r,u)}for(N=s.length-1;N>=r;--N)if(y(s.charCodeAt(N))){if(!b){r=N+1;break}}else u===-1&&(b=!1,u=N+1);return u===-1?"":s.slice(r,u)},extname(s){m(s,"path");let a=0,r=-1,u=0,b=-1,N=!0,R=0;s.length>=2&&s.charCodeAt(1)===S&&g(s.charCodeAt(0))&&(a=u=2);for(let E=s.length-1;E>=a;--E){const P=s.charCodeAt(E);if(y(P)){if(!N){u=E+1;break}continue}b===-1&&(N=!1,b=E+1),P===C?r===-1?r=E:R!==1&&(R=1):r!==-1&&(R=-1)}return r===-1||b===-1||R===0||R===1&&r===b-1&&r===u+1?"":s.slice(r,b)},format:l.bind(null,"\\"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const r=s.length;let u=0,b=s.charCodeAt(0);if(r===1)return y(b)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(y(b)){if(u=1,y(s.charCodeAt(1))){let O=2,q=O;for(;O<r&&!y(s.charCodeAt(O));)O++;if(O<r&&O!==q){for(q=O;O<r&&y(s.charCodeAt(O));)O++;if(O<r&&O!==q){for(q=O;O<r&&!y(s.charCodeAt(O));)O++;O===r?u=O:O!==q&&(u=O+1)}}}}else if(g(b)&&s.charCodeAt(1)===S){if(r<=2)return a.root=a.dir=s,a;if(u=2,y(s.charCodeAt(2))){if(r===3)return a.root=a.dir=s,a;u=3}}u>0&&(a.root=s.slice(0,u));let N=-1,R=u,E=-1,P=!0,F=s.length-1,x=0;for(;F>=u;--F){if(b=s.charCodeAt(F),y(b)){if(!P){R=F+1;break}continue}E===-1&&(P=!1,E=F+1),b===C?N===-1?N=F:x!==1&&(x=1):N!==-1&&(x=-1)}return E!==-1&&(N===-1||x===0||x===1&&N===E-1&&N===R+1?a.base=a.name=s.slice(R,E):(a.name=s.slice(R,N),a.base=s.slice(R,E),a.ext=s.slice(N,E))),R>0&&R!==u?a.dir=s.slice(0,R-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(w){const s=/\\/g;return()=>{const a=A.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>A.cwd()})();n.posix={resolve(...s){let a="",r=!1;for(let u=s.length-1;u>=-1&&!r;u--){const b=u>=0?s[u]:d();m(b,"path"),b.length!==0&&(a=`${b}/${a}`,r=b.charCodeAt(0)===o)}return a=L(a,!r,"/",_),r?`/${a}`:a.length>0?a:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o,r=s.charCodeAt(s.length-1)===o;return s=L(s,!a,"/",_),s.length===0?a?"/":r?"./":".":(r&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let a;for(let r=0;r<s.length;++r){const u=s[r];m(u,"path"),u.length>0&&(a===void 0?a=u:a+=`/${u}`)}return a===void 0?".":n.posix.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a||(s=n.posix.resolve(s),a=n.posix.resolve(a),s===a))return"";const r=1,u=s.length,b=u-r,N=1,R=a.length-N,E=b<R?b:R;let P=-1,F=0;for(;F<E;F++){const O=s.charCodeAt(r+F);if(O!==a.charCodeAt(N+F))break;O===o&&(P=F)}if(F===E)if(R>E){if(a.charCodeAt(N+F)===o)return a.slice(N+F+1);if(F===0)return a.slice(N+F)}else b>E&&(s.charCodeAt(r+F)===o?P=F:F===0&&(P=0));let x="";for(F=r+P+1;F<=u;++F)(F===u||s.charCodeAt(F)===o)&&(x+=x.length===0?"..":"/..");return`${x}${a.slice(N+P)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o;let r=-1,u=!0;for(let b=s.length-1;b>=1;--b)if(s.charCodeAt(b)===o){if(!u){r=b;break}}else u=!1;return r===-1?a?"/":".":a&&r===1?"//":s.slice(0,r)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let r=0,u=-1,b=!0,N;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let R=a.length-1,E=-1;for(N=s.length-1;N>=0;--N){const P=s.charCodeAt(N);if(P===o){if(!b){r=N+1;break}}else E===-1&&(b=!1,E=N+1),R>=0&&(P===a.charCodeAt(R)?--R===-1&&(u=N):(R=-1,u=E))}return r===u?u=E:u===-1&&(u=s.length),s.slice(r,u)}for(N=s.length-1;N>=0;--N)if(s.charCodeAt(N)===o){if(!b){r=N+1;break}}else u===-1&&(b=!1,u=N+1);return u===-1?"":s.slice(r,u)},extname(s){m(s,"path");let a=-1,r=0,u=-1,b=!0,N=0;for(let R=s.length-1;R>=0;--R){const E=s.charCodeAt(R);if(E===o){if(!b){r=R+1;break}continue}u===-1&&(b=!1,u=R+1),E===C?a===-1?a=R:N!==1&&(N=1):a!==-1&&(N=-1)}return a===-1||u===-1||N===0||N===1&&a===u-1&&a===r+1?"":s.slice(a,u)},format:l.bind(null,"/"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const r=s.charCodeAt(0)===o;let u;r?(a.root="/",u=1):u=0;let b=-1,N=0,R=-1,E=!0,P=s.length-1,F=0;for(;P>=u;--P){const x=s.charCodeAt(P);if(x===o){if(!E){N=P+1;break}continue}R===-1&&(E=!1,R=P+1),x===C?b===-1?b=P:F!==1&&(F=1):b!==-1&&(F=-1)}if(R!==-1){const x=N===0&&r?1:N;b===-1||F===0||F===1&&b===R-1&&b===N+1?a.base=a.name=s.slice(x,R):(a.name=s.slice(x,b),a.base=s.slice(x,R),a.ext=s.slice(b,R))}return N>0?a.dir=s.slice(0,N-1):r&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=w?n.win32.normalize:n.posix.normalize,n.resolve=w?n.win32.resolve:n.posix.resolve,n.relative=w?n.win32.relative:n.posix.relative,n.dirname=w?n.win32.dirname:n.posix.dirname,n.basename=w?n.win32.basename:n.posix.basename,n.extname=w?n.win32.extname:n.posix.extname,n.sep=w?n.win32.sep:n.posix.sep}),Y(X[21],Q([0,1,5]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const M=A.globals.performance&&typeof A.globals.performance.now=="function";class i{static create(p=!0){return new i(p)}constructor(p){this.a=M&&p,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?A.globals.performance.now():Date.now()}}n.StopWatch=i}),Y(X[7],Q([0,1,8,10,14,21]),function(U,n,A,M,i,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.EventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const p=!1,C=!1;var o;(function(a){a.None=()=>M.Disposable.None;function r(J){if(C){const{onDidAddListener:H}=J,$=v.create();let G=0;J.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$.print()),H?.()}}}function u(J,H){return q(J,()=>{},0,void 0,void 0,H)}a.defer=u;function b(J){return(H,$=null,G)=>{let K=!1,ee;return ee=J(te=>{if(!K)return ee?ee.dispose():K=!0,H.call($,te)},null,G),K&&ee.dispose(),ee}}a.once=b;function N(J,H,$){return O((G,K=null,ee)=>J(te=>G.call(K,H(te)),null,ee),$)}a.map=N;function R(J,H,$){return O((G,K=null,ee)=>J(te=>{H(te),G.call(K,te)},null,ee),$)}a.forEach=R;function E(J,H,$){return O((G,K=null,ee)=>J(te=>H(te)&&G.call(K,te),null,ee),$)}a.filter=E;function P(J){return J}a.signal=P;function F(...J){return(H,$=null,G)=>(0,M.combinedDisposable)(...J.map(K=>K(ee=>H.call($,ee),null,G)))}a.any=F;function x(J,H,$,G){let K=$;return N(J,ee=>(K=H(K,ee),K),G)}a.reduce=x;function O(J,H){let $;const G={onWillAddFirstListener(){$=J(K.fire,K)},onDidRemoveLastListener(){$?.dispose()}};H||r(G);const K=new m(G);return H?.add(K),K.event}function q(J,H,$=100,G=!1,K,ee){let te,ne,be,Le=0;const we={leakWarningThreshold:K,onWillAddFirstListener(){te=J(ue=>{Le++,ne=H(ne,ue),G&&!be&&(Ce.fire(ne),ne=void 0);const de=()=>{const D=ne;ne=void 0,be=void 0,(!G||Le>1)&&Ce.fire(D),Le=0};typeof $=="number"?(clearTimeout(be),be=setTimeout(de,$)):be===void 0&&(be=0,queueMicrotask(de))})},onDidRemoveLastListener(){te.dispose()}};ee||r(we);const Ce=new m(we);return ee?.add(Ce),Ce.event}a.debounce=q;function k(J,H=0,$){return a.debounce(J,(G,K)=>G?(G.push(K),G):[K],H,void 0,void 0,$)}a.accumulate=k;function I(J,H=(G,K)=>G===K,$){let G=!0,K;return E(J,ee=>{const te=G||!H(ee,K);return G=!1,K=ee,te},$)}a.latch=I;function T(J,H,$){return[a.filter(J,H,$),a.filter(J,G=>!H(G),$)]}a.split=T;function W(J,H=!1,$=[]){let G=$.slice(),K=J(ne=>{G?G.push(ne):te.fire(ne)});const ee=()=>{G?.forEach(ne=>te.fire(ne)),G=null},te=new m({onWillAddFirstListener(){K||(K=J(ne=>te.fire(ne)))},onDidAddFirstListener(){G&&(H?setTimeout(ee):ee())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return te.event}a.buffer=W;class z{constructor(H){this.event=H,this.c=new M.DisposableStore}map(H){return new z(N(this.event,H,this.c))}forEach(H){return new z(R(this.event,H,this.c))}filter(H){return new z(E(this.event,H,this.c))}reduce(H,$){return new z(x(this.event,H,$,this.c))}latch(){return new z(I(this.event,void 0,this.c))}debounce(H,$=100,G=!1,K){return new z(q(this.event,H,$,G,K,this.c))}on(H,$,G){return this.event(H,$,G)}once(H,$,G){return b(this.event)(H,$,G)}dispose(){this.c.dispose()}}function t(J){return new z(J)}a.chain=t;function se(J,H,$=G=>G){const G=(...ne)=>te.fire($(...ne)),K=()=>J.on(H,G),ee=()=>J.removeListener(H,G),te=new m({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}a.fromNodeEventEmitter=se;function ge(J,H,$=G=>G){const G=(...ne)=>te.fire($(...ne)),K=()=>J.addEventListener(H,G),ee=()=>J.removeEventListener(H,G),te=new m({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}a.fromDOMEventEmitter=ge;function me(J){return new Promise(H=>b(J)(H))}a.toPromise=me;function ye(J,H){return H(void 0),J($=>H($))}a.runAndSubscribe=ye;function Se(J,H){let $=null;function G(ee){$?.dispose(),$=new M.DisposableStore,H(ee,$)}G(void 0);const K=J(ee=>G(ee));return(0,M.toDisposable)(()=>{K.dispose(),$?.dispose()})}a.runAndSubscribeWithStore=Se;class Ne{constructor(H,$){this.obs=H,this.c=0,this.d=!1;const G={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};$||r(G),this.emitter=new m(G),$&&$.add(this.emitter)}beginUpdate(H){this.c++}handleChange(H,$){this.d=!0}endUpdate(H){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function _e(J,H){return new Ne(J,H).emitter.event}a.fromObservable=_e})(o=n.Event||(n.Event={}));class f{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${f.c++}`,f.all.add(this)}start(r){this.d=new c.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}n.EventProfiling=f,f.all=new Set,f.c=0;let S=-1;class e{constructor(r,u=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=u,this.d=0}dispose(){var r;(r=this.c)===null||r===void 0||r.clear()}check(r,u){const b=this.threshold;if(b<=0||u<b)return;this.c||(this.c=new Map);const N=this.c.get(r.value)||0;if(this.c.set(r.value,N+1),this.d-=1,this.d<=0){this.d=b*.5;let R,E=0;for(const[P,F]of this.c)(!R||E<F)&&(R=P,E=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${E}):`),console.warn(R)}return()=>{const R=this.c.get(r.value)||0;this.c.set(r.value,R-1)}}}class v{static create(){var r;return new v((r=new Error().stack)!==null&&r!==void 0?r:"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(r,u,b){this.callback=r,this.callbackThis=u,this.stack=b,this.subscription=new M.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class m{constructor(r){var u,b,N,R,E;this.j=!1,this.d=r,this.f=S>0||((u=this.d)===null||u===void 0?void 0:u.leakWarningThreshold)?new e((N=(b=this.d)===null||b===void 0?void 0:b.leakWarningThreshold)!==null&&N!==void 0?N:S):void 0,this.g=!((R=this.d)===null||R===void 0)&&R._profName?new f(this.d._profName):void 0,this.m=(E=this.d)===null||E===void 0?void 0:E.deliveryQueue}dispose(){var r,u,b,N;if(!this.j){if(this.j=!0,this.n){if(p){const R=Array.from(this.n);queueMicrotask(()=>{var E;for(const P of R)P.subscription.isset()&&(P.subscription.unset(),(E=P.stack)===null||E===void 0||E.print())})}this.n.clear()}(r=this.m)===null||r===void 0||r.clear(this),(b=(u=this.d)===null||u===void 0?void 0:u.onDidRemoveLastListener)===null||b===void 0||b.call(u),(N=this.f)===null||N===void 0||N.dispose()}}get event(){return this.l||(this.l=(r,u,b)=>{var N,R,E;if(this.n||(this.n=new i.LinkedList),this.f&&this.n.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.Disposable.None;const P=this.n.isEmpty();P&&((N=this.d)===null||N===void 0?void 0:N.onWillAddFirstListener)&&this.d.onWillAddFirstListener(this);let F,x;this.f&&this.n.size>=Math.ceil(this.f.threshold*.2)&&(x=v.create(),F=this.f.check(x,this.n.size+1)),p&&(x=x??v.create());const O=new h(r,u,x),q=this.n.push(O);P&&((R=this.d)===null||R===void 0?void 0:R.onDidAddFirstListener)&&this.d.onDidAddFirstListener(this),!((E=this.d)===null||E===void 0)&&E.onDidAddListener&&this.d.onDidAddListener(this,r,u);const k=O.subscription.set(()=>{F?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.n&&!this.n.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof M.DisposableStore?b.add(k):Array.isArray(b)&&b.push(k),k}),this.l}fire(r){var u,b;if(this.n){this.m||(this.m=new y);for(const N of this.n)this.m.push(this,N,r);(u=this.g)===null||u===void 0||u.start(this.m.size),this.m.deliver(),(b=this.g)===null||b===void 0||b.stop()}}hasListeners(){return this.n?!this.n.isEmpty():!1}}n.Emitter=m;class w{constructor(){this.c=new i.LinkedList}get size(){return this.c.size}push(r,u,b){this.c.push(new _(r,u,b))}clear(r){const u=new i.LinkedList;for(const b of this.c)b.emitter!==r&&u.push(b);this.c=u}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(u){(0,A.onUnexpectedError)(u)}}}}n.EventDeliveryQueue=w;class y extends w{clear(r){this.c.clear()}}class _{constructor(r,u,b){this.emitter=r,this.listener=u,this.event=b}}class g extends m{constructor(r){super(r),this.c=0,this.h=new i.LinkedList,this.k=r?.merge}pause(){this.c++}resume(){if(this.c!==0&&--this.c===0)if(this.k){if(this.h.size>0){const r=Array.from(this.h);this.h.clear(),super.fire(this.k(r))}}else for(;!this.c&&this.h.size!==0;)super.fire(this.h.shift())}fire(r){this.n&&(this.c!==0?this.h.push(r):super.fire(r))}}n.PauseableEmitter=g;class L extends g{constructor(r){var u;super(r),this.o=(u=r.delay)!==null&&u!==void 0?u:100}fire(r){this.p||(this.pause(),this.p=setTimeout(()=>{this.p=void 0,this.resume()},this.o)),super.fire(r)}}n.DebounceEmitter=L;class l extends m{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}n.MicrotaskEmitter=l;class d{constructor(){this.c=[]}wrapEvent(r){return(u,b,N)=>r(R=>{const E=this.c[this.c.length-1];E?E.push(()=>u.call(b,R)):u.call(b,R)},void 0,N)}bufferEvents(r){const u=[];this.c.push(u);const b=r();return this.c.pop(),u.forEach(N=>N()),b}}n.EventBufferer=d;class s{constructor(){this.c=!1,this.d=o.None,this.f=M.Disposable.None,this.g=new m({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}n.Relay=s}),Y(X[51],Q([0,1,7]),function(U,n,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(C,o){const f=setTimeout(C.bind(o),0);return{dispose(){clearTimeout(f)}}});var i;(function(C){function o(f){return f===C.None||f===C.Cancelled||f instanceof c?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}C.isCancellationToken=o,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i=n.CancellationToken||(n.CancellationToken={}));class c{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new A.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(o){this.a=void 0,this.b=void 0,this.b=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new c),this.a}cancel(){this.a?this.a instanceof c&&this.a.cancel():this.a=i.Cancelled}dispose(o=!1){var f;o&&this.cancel(),(f=this.b)===null||f===void 0||f.dispose(),this.a?this.a instanceof c&&this.a.dispose():this.a=i.None}}n.CancellationTokenSource=p}),Y(X[12],Q([0,1,50,5]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,c=/^\//,p=/^\/\//;function C(r,u){if(!r.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!i.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!c.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(r,u){return!r&&!u?"file":r}function f(r,u){switch(r){case"https":case"http":case"file":u?u[0]!==e&&(u=e+u):u=e;break}return u}const S="",e="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(u){return u instanceof h?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,b,N,R,E,P=!1){typeof u=="object"?(this.scheme=u.scheme||S,this.authority=u.authority||S,this.path=u.path||S,this.query=u.query||S,this.fragment=u.fragment||S):(this.scheme=o(u,P),this.authority=b||S,this.path=f(this.scheme,N||S),this.query=R||S,this.fragment=E||S,C(this,P))}get fsPath(){return L(this,!1)}with(u){if(!u)return this;let{scheme:b,authority:N,path:R,query:E,fragment:P}=u;return b===void 0?b=this.scheme:b===null&&(b=S),N===void 0?N=this.authority:N===null&&(N=S),R===void 0?R=this.path:R===null&&(R=S),E===void 0?E=this.query:E===null&&(E=S),P===void 0?P=this.fragment:P===null&&(P=S),b===this.scheme&&N===this.authority&&R===this.path&&E===this.query&&P===this.fragment?this:new w(b,N,R,E,P)}static parse(u,b=!1){const N=v.exec(u);return N?new w(N[2]||S,a(N[4]||S),a(N[5]||S),a(N[7]||S),a(N[9]||S),b):new w(S,S,S,S,S)}static file(u){let b=S;if(M.isWindows&&(u=u.replace(/\\/g,e)),u[0]===e&&u[1]===e){const N=u.indexOf(e,2);N===-1?(b=u.substring(2),u=e):(b=u.substring(2,N),u=u.substring(N)||e)}return new w("file",b,u,S,S)}static from(u){const b=new w(u.scheme,u.authority,u.path,u.query,u.fragment);return C(b,!0),b}static joinPath(u,...b){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return M.isWindows&&u.scheme==="file"?N=h.file(A.win32.join(L(u,!0),...b)).path:N=A.posix.join(u.path,...b),u.with({path:N})}toString(u=!1){return l(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof h)return u;{const b=new w(u);return b._formatted=u.external,b._fsPath=u._sep===m?u.fsPath:null,b}}else return u}}n.URI=h;const m=M.isWindows?1:void 0;class w extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=L(this,!1)),this._fsPath}toString(u=!1){return u?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=m),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(r,u,b){let N,R=-1;for(let E=0;E<r.length;E++){const P=r.charCodeAt(E);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||u&&P===47||b&&P===91||b&&P===93||b&&P===58)R!==-1&&(N+=encodeURIComponent(r.substring(R,E)),R=-1),N!==void 0&&(N+=r.charAt(E));else{N===void 0&&(N=r.substr(0,E));const F=y[P];F!==void 0?(R!==-1&&(N+=encodeURIComponent(r.substring(R,E)),R=-1),N+=F):R===-1&&(R=E)}}return R!==-1&&(N+=encodeURIComponent(r.substring(R))),N!==void 0?N:r}function g(r){let u;for(let b=0;b<r.length;b++){const N=r.charCodeAt(b);N===35||N===63?(u===void 0&&(u=r.substr(0,b)),u+=y[N]):u!==void 0&&(u+=r[b])}return u!==void 0?u:r}function L(r,u){let b;return r.authority&&r.path.length>1&&r.scheme==="file"?b=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?u?b=r.path.substr(1):b=r.path[1].toLowerCase()+r.path.substr(2):b=r.path,M.isWindows&&(b=b.replace(/\//g,"\\")),b}n.uriToFsPath=L;function l(r,u){const b=u?g:_;let N="",{scheme:R,authority:E,path:P,query:F,fragment:x}=r;if(R&&(N+=R,N+=":"),(E||R==="file")&&(N+=e,N+=e),E){let O=E.indexOf("@");if(O!==-1){const q=E.substr(0,O);E=E.substr(O+1),O=q.lastIndexOf(":"),O===-1?N+=b(q,!1,!1):(N+=b(q.substr(0,O),!1,!1),N+=":",N+=b(q.substr(O+1),!1,!0)),N+="@"}E=E.toLowerCase(),O=E.lastIndexOf(":"),O===-1?N+=b(E,!1,!0):(N+=b(E.substr(0,O),!1,!0),N+=E.substr(O))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const O=P.charCodeAt(1);O>=65&&O<=90&&(P=`/${String.fromCharCode(O+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const O=P.charCodeAt(0);O>=65&&O<=90&&(P=`${String.fromCharCode(O+32)}:${P.substr(2)}`)}N+=b(P,!0,!1)}return F&&(N+="?",N+=b(F,!1,!1)),x&&(N+="#",N+=u?x:_(x,!1,!1)),N}function d(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+d(r.substr(3)):r}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(r){return r.match(s)?r.replace(s,u=>d(u)):r}}),Y(X[56],Q([0,1,8,7,10,11,5,4]),function(U,n,A,M,i,c,p,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const o="$initialize";let f=!1;function S(a){!p.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}n.logOnceWebWorkerWarning=S;class e{constructor(r,u,b,N){this.vsWorker=r,this.req=u,this.method=b,this.args=N,this.type=0}}class v{constructor(r,u,b,N){this.vsWorker=r,this.seq=u,this.res=b,this.err=N,this.type=1}}class h{constructor(r,u,b,N){this.vsWorker=r,this.req=u,this.eventName=b,this.arg=N,this.type=2}}class m{constructor(r,u,b){this.vsWorker=r,this.req=u,this.event=b,this.type=3}}class w{constructor(r,u){this.vsWorker=r,this.req=u,this.type=4}}class y{constructor(r){this.a=-1,this.g=r,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(r){this.a=r}sendMessage(r,u){const b=String(++this.b);return new Promise((N,R)=>{this.c[b]={resolve:N,reject:R},this.o(new e(this.a,b,r,u))})}listen(r,u){let b=null;const N=new M.Emitter({onWillAddFirstListener:()=>{b=String(++this.b),this.d.set(b,N),this.o(new h(this.a,b,r,u))},onDidRemoveLastListener:()=>{this.d.delete(b),this.o(new w(this.a,b)),b=null}});return N.event}handleMessage(r){!r||!r.vsWorker||this.a!==-1&&r.vsWorker!==this.a||this.h(r)}h(r){switch(r.type){case 1:return this.j(r);case 0:return this.k(r);case 2:return this.l(r);case 3:return this.m(r);case 4:return this.n(r)}}j(r){if(!this.c[r.seq]){console.warn("Got reply to unknown seq");return}const u=this.c[r.seq];if(delete this.c[r.seq],r.err){let b=r.err;r.err.$isError&&(b=new Error,b.name=r.err.name,b.message=r.err.message,b.stack=r.err.stack),u.reject(b);return}u.resolve(r.res)}k(r){const u=r.req;this.g.handleMessage(r.method,r.args).then(N=>{this.o(new v(this.a,u,N,void 0))},N=>{N.detail instanceof Error&&(N.detail=(0,A.transformErrorForSerialization)(N.detail)),this.o(new v(this.a,u,void 0,(0,A.transformErrorForSerialization)(N)))})}l(r){const u=r.req,b=this.g.handleEvent(r.eventName,r.arg)(N=>{this.o(new m(this.a,u,N))});this.f.set(u,b)}m(r){if(!this.d.has(r.req)){console.warn("Got event for unknown req");return}this.d.get(r.req).fire(r.event)}n(r){if(!this.f.has(r.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(r.req).dispose(),this.f.delete(r.req)}o(r){const u=[];if(r.type===0)for(let b=0;b<r.args.length;b++)r.args[b]instanceof ArrayBuffer&&u.push(r.args[b]);else r.type===1&&r.res instanceof ArrayBuffer&&u.push(r.res);this.g.sendMessage(r,u)}}class _ extends i.Disposable{constructor(r,u,b){super();let N=null;this.a=this.q(r.create("vs/base/common/worker/simpleWorker",x=>{this.c.handleMessage(x)},x=>{N?.(x)})),this.c=new y({sendMessage:(x,O)=>{this.a.postMessage(x,O)},handleMessage:(x,O)=>{if(typeof b[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(b[x].apply(b,O))}catch(q){return Promise.reject(q)}},handleEvent:(x,O)=>{if(L(x)){const q=b[x].call(b,O);if(typeof q!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return q}if(g(x)){const q=b[x];if(typeof q!="function")throw new Error(`Missing event ${x} on main thread host.`);return q}throw new Error(`Malformed event name ${x}`)}}),this.c.setWorkerId(this.a.getId());let R=null;typeof p.globals.require<"u"&&typeof p.globals.require.getConfig=="function"?R=p.globals.require.getConfig():typeof p.globals.requirejs<"u"&&(R=p.globals.requirejs.s.contexts._.config);const E=(0,c.getAllMethodNames)(b);this.b=this.c.sendMessage(o,[this.a.getId(),JSON.parse(JSON.stringify(R)),u,E]);const P=(x,O)=>this.h(x,O),F=(x,O)=>this.c.listen(x,O);this.g=new Promise((x,O)=>{N=O,this.b.then(q=>{x(l(q,P,F))},q=>{O(q),this.j("Worker failed to load "+u,q)})})}getProxyObject(){return this.g}h(r,u){return new Promise((b,N)=>{this.b.then(()=>{this.c.sendMessage(r,u).then(b,N)},N)})}j(r,u){console.error(r),console.info(u)}}n.SimpleWorkerClient=_;function g(a){return a[0]==="o"&&a[1]==="n"&&C.isUpperAsciiLetter(a.charCodeAt(2))}function L(a){return/^onDynamic/.test(a)&&C.isUpperAsciiLetter(a.charCodeAt(9))}function l(a,r,u){const b=E=>function(){const P=Array.prototype.slice.call(arguments,0);return r(E,P)},N=E=>function(P){return u(E,P)},R={};for(const E of a){if(L(E)){R[E]=N(E);continue}if(g(E)){R[E]=u(E,void 0);continue}R[E]=b(E)}return R}class d{constructor(r,u){this.a=u,this.b=null,this.c=new y({sendMessage:(b,N)=>{r(b,N)},handleMessage:(b,N)=>this.d(b,N),handleEvent:(b,N)=>this.f(b,N)})}onmessage(r){this.c.handleMessage(r)}d(r,u){if(r===o)return this.g(u[0],u[1],u[2],u[3]);if(!this.b||typeof this.b[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.b[r].apply(this.b,u))}catch(b){return Promise.reject(b)}}f(r,u){if(!this.b)throw new Error("Missing requestHandler");if(L(r)){const b=this.b[r].call(this.b,u);if(typeof b!="function")throw new Error(`Missing dynamic event ${r} on request handler.`);return b}if(g(r)){const b=this.b[r];if(typeof b!="function")throw new Error(`Missing event ${r} on request handler.`);return b}throw new Error(`Malformed event name ${r}`)}g(r,u,b,N){this.c.setWorkerId(r);const P=l(N,(F,x)=>this.c.sendMessage(F,x),(F,x)=>this.c.listen(F,x));return this.a?(this.b=this.a(P),Promise.resolve((0,c.getAllMethodNames)(this.b))):(u&&(typeof u.baseUrl<"u"&&delete u.baseUrl,typeof u.paths<"u"&&typeof u.paths.vs<"u"&&delete u.paths.vs,typeof u.trustedTypesPolicy!==void 0&&delete u.trustedTypesPolicy,u.catchError=!0,p.globals.require.config(u)),new Promise((F,x)=>{(p.globals.require||U)([b],q=>{if(this.b=q.create(P),!this.b){x(new Error("No RequestHandler!"));return}F((0,c.getAllMethodNames)(this.b))},x)}))}}n.SimpleWorkerServer=d;function s(a){return new d(a,null)}n.create=s}),Y(X[52],Q([0,1,7,10]),function(U,n,A,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=null}fire(C){this.c.fire({changedLanguages:C,changedColorMap:!1})}register(C,o){return this.a.set(C,o),this.fire([C]),(0,M.toDisposable)(()=>{this.a.get(C)===o&&(this.a.delete(C),this.fire([C]))})}registerFactory(C,o){var f;(f=this.b.get(C))===null||f===void 0||f.dispose();const S=new c(this,C,o);return this.b.set(C,S),(0,M.toDisposable)(()=>{const e=this.b.get(C);!e||e!==S||(this.b.delete(C),e.dispose())})}getOrCreate(C){return le(this,void 0,void 0,function*(){const o=this.get(C);if(o)return o;const f=this.b.get(C);return!f||f.isResolved?null:(yield f.resolve(),this.get(C))})}get(C){return this.a.get(C)||null}isResolved(C){if(this.get(C))return!0;const f=this.b.get(C);return!!(!f||f.isResolved)}setColorMap(C){this.d=C,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}n.TokenizationRegistry=i;class c extends M.Disposable{get isResolved(){return this.c}constructor(C,o,f){super(),this.g=C,this.h=o,this.i=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}resolve(){return le(this,void 0,void 0,function*(){return this.b||(this.b=this.j()),this.b})}j(){return le(this,void 0,void 0,function*(){const C=yield Promise.resolve(this.i.createTokenizationSupport());this.c=!0,C&&!this.a&&this.q(this.g.register(this.h,C))})}}}),Y(X[53],Q([0,1,30,12,2,52]),function(U,n,A,M,i,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class p{constructor(L,l,d){this._tokenBrand=void 0,this.offset=L,this.type=l,this.language=d}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=p;class C{constructor(L,l){this._tokenizationResultBrand=void 0,this.tokens=L,this.endState=l}}n.TokenizationResult=C;class o{constructor(L,l){this._encodedTokenizationResultBrand=void 0,this.tokens=L,this.endState=l}}n.EncodedTokenizationResult=o;var f;(function(g){const L=new Map;L.set(0,A.Codicon.symbolMethod),L.set(1,A.Codicon.symbolFunction),L.set(2,A.Codicon.symbolConstructor),L.set(3,A.Codicon.symbolField),L.set(4,A.Codicon.symbolVariable),L.set(5,A.Codicon.symbolClass),L.set(6,A.Codicon.symbolStruct),L.set(7,A.Codicon.symbolInterface),L.set(8,A.Codicon.symbolModule),L.set(9,A.Codicon.symbolProperty),L.set(10,A.Codicon.symbolEvent),L.set(11,A.Codicon.symbolOperator),L.set(12,A.Codicon.symbolUnit),L.set(13,A.Codicon.symbolValue),L.set(15,A.Codicon.symbolEnum),L.set(14,A.Codicon.symbolConstant),L.set(15,A.Codicon.symbolEnum),L.set(16,A.Codicon.symbolEnumMember),L.set(17,A.Codicon.symbolKeyword),L.set(27,A.Codicon.symbolSnippet),L.set(18,A.Codicon.symbolText),L.set(19,A.Codicon.symbolColor),L.set(20,A.Codicon.symbolFile),L.set(21,A.Codicon.symbolReference),L.set(22,A.Codicon.symbolCustomColor),L.set(23,A.Codicon.symbolFolder),L.set(24,A.Codicon.symbolTypeParameter),L.set(25,A.Codicon.account),L.set(26,A.Codicon.issues);function l(a){let r=L.get(a);return r||(console.info("No codicon found for CompletionItemKind "+a),r=A.Codicon.symbolProperty),r}g.toIcon=l;const d=new Map;d.set("method",0),d.set("function",1),d.set("constructor",2),d.set("field",3),d.set("variable",4),d.set("class",5),d.set("struct",6),d.set("interface",7),d.set("module",8),d.set("property",9),d.set("event",10),d.set("operator",11),d.set("unit",12),d.set("value",13),d.set("constant",14),d.set("enum",15),d.set("enum-member",16),d.set("enumMember",16),d.set("keyword",17),d.set("snippet",27),d.set("text",18),d.set("color",19),d.set("file",20),d.set("reference",21),d.set("customcolor",22),d.set("folder",23),d.set("type-parameter",24),d.set("typeParameter",24),d.set("account",25),d.set("issue",26);function s(a,r){let u=d.get(a);return typeof u>"u"&&!r&&(u=9),u}g.fromString=s})(f=n.CompletionItemKinds||(n.CompletionItemKinds={}));var S;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(S=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var e;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(e=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var v;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(v=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function h(g){return g&&M.URI.isUri(g.uri)&&i.Range.isIRange(g.range)&&(i.Range.isIRange(g.originSelectionRange)||i.Range.isIRange(g.targetSelectionRange))}n.isLocationLink=h;var m;(function(g){const L=new Map;L.set(0,A.Codicon.symbolFile),L.set(1,A.Codicon.symbolModule),L.set(2,A.Codicon.symbolNamespace),L.set(3,A.Codicon.symbolPackage),L.set(4,A.Codicon.symbolClass),L.set(5,A.Codicon.symbolMethod),L.set(6,A.Codicon.symbolProperty),L.set(7,A.Codicon.symbolField),L.set(8,A.Codicon.symbolConstructor),L.set(9,A.Codicon.symbolEnum),L.set(10,A.Codicon.symbolInterface),L.set(11,A.Codicon.symbolFunction),L.set(12,A.Codicon.symbolVariable),L.set(13,A.Codicon.symbolConstant),L.set(14,A.Codicon.symbolString),L.set(15,A.Codicon.symbolNumber),L.set(16,A.Codicon.symbolBoolean),L.set(17,A.Codicon.symbolArray),L.set(18,A.Codicon.symbolObject),L.set(19,A.Codicon.symbolKey),L.set(20,A.Codicon.symbolNull),L.set(21,A.Codicon.symbolEnumMember),L.set(22,A.Codicon.symbolStruct),L.set(23,A.Codicon.symbolEvent),L.set(24,A.Codicon.symbolOperator),L.set(25,A.Codicon.symbolTypeParameter);function l(d){let s=L.get(d);return s||(console.info("No codicon found for SymbolKind "+d),s=A.Codicon.symbolProperty),s}g.toIcon=l})(m=n.SymbolKinds||(n.SymbolKinds={}));class w{constructor(L){this.value=L}}n.FoldingRangeKind=w,w.Comment=new w("comment"),w.Imports=new w("imports"),w.Region=new w("region");var y;(function(g){function L(l){return!l||typeof l!="object"?!1:typeof l.id=="string"&&typeof l.title=="string"}g.is=L})(y=n.Command||(n.Command={}));var _;(function(g){g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(_=n.InlayHintKind||(n.InlayHintKind={})),n.TokenizationRegistry=new c.TokenizationRegistry}),Y(X[54],Q([0,1,51,7,27,12,3,2,31,53,47]),function(U,n,A,M,i,c,p,C,o,f,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(m,w){return(0,i.KeyChord)(m,w)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function v(){return{editor:void 0,languages:void 0,CancellationTokenSource:A.CancellationTokenSource,Emitter:M.Emitter,KeyCode:S.KeyCode,KeyMod:e,Position:p.Position,Range:C.Range,Selection:o.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:c.URI,Token:f.Token}}n.createMonacoBaseAPI=v}),Y(X[57],Q([0,1,15,5,12,3,2,44,19,40,41,54,21,46,39,11]),function(U,n,A,M,i,c,p,C,o,f,S,e,v,h,m,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class y extends C.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(l){return this.d[l-1]}getWordAtPosition(l,d){const s=(0,o.getWordAtText)(l.column,(0,o.ensureValidWordDefinition)(d),this.d[l.lineNumber-1],0);return s?new p.Range(l.lineNumber,s.startColumn,l.lineNumber,s.endColumn):null}words(l){const d=this.d,s=this.p.bind(this);let a=0,r="",u=0,b=[];return{*[Symbol.iterator](){for(;;)if(u<b.length){const N=r.substring(b[u].start,b[u].end);u+=1,yield N}else if(a<d.length)r=d[a],b=s(r,l),u=0,a+=1;else break}}}getLineWords(l,d){const s=this.d[l-1],a=this.p(s,d),r=[];for(const u of a)r.push({word:s.substring(u.start,u.end),startColumn:u.start+1,endColumn:u.end+1});return r}p(l,d){const s=[];let a;for(d.lastIndex=0;(a=d.exec(l))&&a[0].length!==0;)s.push({start:a.index,end:a.index+a[0].length});return s}getValueInRange(l){if(l=this.q(l),l.startLineNumber===l.endLineNumber)return this.d[l.startLineNumber-1].substring(l.startColumn-1,l.endColumn-1);const d=this.f,s=l.startLineNumber-1,a=l.endLineNumber-1,r=[];r.push(this.d[s].substring(l.startColumn-1));for(let u=s+1;u<a;u++)r.push(this.d[u]);return r.push(this.d[a].substring(0,l.endColumn-1)),r.join(d)}offsetAt(l){return l=this.r(l),this.k(),this.h.getPrefixSum(l.lineNumber-2)+(l.column-1)}positionAt(l){l=Math.floor(l),l=Math.max(0,l),this.k();const d=this.h.getIndexOf(l),s=this.d[d.index].length;return{lineNumber:1+d.index,column:1+Math.min(d.remainder,s)}}q(l){const d=this.r({lineNumber:l.startLineNumber,column:l.startColumn}),s=this.r({lineNumber:l.endLineNumber,column:l.endColumn});return d.lineNumber!==l.startLineNumber||d.column!==l.startColumn||s.lineNumber!==l.endLineNumber||s.column!==l.endColumn?{startLineNumber:d.lineNumber,startColumn:d.column,endLineNumber:s.lineNumber,endColumn:s.column}:l}r(l){if(!c.Position.isIPosition(l))throw new Error("bad position");let{lineNumber:d,column:s}=l,a=!1;if(d<1)d=1,s=1,a=!0;else if(d>this.d.length)d=this.d.length,s=this.d[d-1].length+1,a=!0;else{const r=this.d[d-1].length+1;s<1?(s=1,a=!0):s>r&&(s=r,a=!0)}return a?{lineNumber:d,column:s}:l}}class _{constructor(l,d){this.c=l,this.d=Object.create(null),this.f=d,this.g=null}dispose(){this.d=Object.create(null)}h(l){return this.d[l]}j(){const l=[];return Object.keys(this.d).forEach(d=>l.push(this.d[d])),l}acceptNewModel(l){this.d[l.url]=new y(i.URI.parse(l.url),l.lines,l.EOL,l.versionId)}acceptModelChanged(l,d){if(!this.d[l])return;this.d[l].onEvents(d)}acceptRemovedModel(l){!this.d[l]||delete this.d[l]}computeUnicodeHighlights(l,d,s){return le(this,void 0,void 0,function*(){const a=this.h(l);return a?h.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,d,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(l,d,s,a){return le(this,void 0,void 0,function*(){const r=this.h(l),u=this.h(d);return!r||!u?null:_.k(r,u,s,a)})}static k(l,d,s,a){const r=a==="experimental"?m.linesDiffComputers.experimental:m.linesDiffComputers.smart,u=l.getLinesContent(),b=d.getLinesContent(),N=r.computeDiff(u,b,s);return{identical:N.changes.length>0?!1:this.l(l,d),quitEarly:N.quitEarly,changes:N.changes.map(E=>{var P;return[E.originalRange.startLineNumber,E.originalRange.endLineNumberExclusive,E.modifiedRange.startLineNumber,E.modifiedRange.endLineNumberExclusive,(P=E.innerChanges)===null||P===void 0?void 0:P.map(F=>[F.originalRange.startLineNumber,F.originalRange.startColumn,F.originalRange.endLineNumber,F.originalRange.endColumn,F.modifiedRange.startLineNumber,F.modifiedRange.startColumn,F.modifiedRange.endLineNumber,F.modifiedRange.endColumn])]})}}static l(l,d){const s=l.getLineCount(),a=d.getLineCount();if(s!==a)return!1;for(let r=1;r<=s;r++){const u=l.getLineContent(r),b=d.getLineContent(r);if(u!==b)return!1}return!0}computeMoreMinimalEdits(l,d){return le(this,void 0,void 0,function*(){const s=this.h(l);if(!s)return d;const a=[];let r;d=d.slice(0).sort((u,b)=>{if(u.range&&b.range)return p.Range.compareRangesUsingStarts(u.range,b.range);const N=u.range?0:1,R=b.range?0:1;return N-R});for(let{range:u,text:b,eol:N}of d){if(typeof N=="number"&&(r=N),p.Range.isEmpty(u)&&!b)continue;const R=s.getValueInRange(u);if(b=b.replace(/\r\n|\n|\r/g,s.eol),R===b)continue;if(Math.max(b.length,R.length)>_.n){a.push({range:u,text:b});continue}const E=(0,A.stringDiff)(R,b,!1),P=s.offsetAt(p.Range.lift(u).getStartPosition());for(const F of E){const x=s.positionAt(P+F.originalStart),O=s.positionAt(P+F.originalStart+F.originalLength),q={text:b.substr(F.modifiedStart,F.modifiedLength),range:{startLineNumber:x.lineNumber,startColumn:x.column,endLineNumber:O.lineNumber,endColumn:O.column}};s.getValueInRange(q.range)!==q.text&&a.push(q)}}return typeof r=="number"&&a.push({eol:r,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a})}computeLinks(l){return le(this,void 0,void 0,function*(){const d=this.h(l);return d?(0,f.computeLinks)(d):null})}textualSuggest(l,d,s,a){return le(this,void 0,void 0,function*(){const r=new v.StopWatch(!0),u=new RegExp(s,a),b=new Set;e:for(const N of l){const R=this.h(N);if(!!R){for(const E of R.words(u))if(!(E===d||!isNaN(Number(E)))&&(b.add(E),b.size>_.o))break e}}return{words:Array.from(b),duration:r.elapsed()}})}computeWordRanges(l,d,s,a){return le(this,void 0,void 0,function*(){const r=this.h(l);if(!r)return Object.create(null);const u=new RegExp(s,a),b=Object.create(null);for(let N=d.startLineNumber;N<d.endLineNumber;N++){const R=r.getLineWords(N,u);for(const E of R){if(!isNaN(Number(E.word)))continue;let P=b[E.word];P||(P=[],b[E.word]=P),P.push({startLineNumber:N,startColumn:E.startColumn,endLineNumber:N,endColumn:E.endColumn})}}return b})}navigateValueSet(l,d,s,a,r){return le(this,void 0,void 0,function*(){const u=this.h(l);if(!u)return null;const b=new RegExp(a,r);d.startColumn===d.endColumn&&(d={startLineNumber:d.startLineNumber,startColumn:d.startColumn,endLineNumber:d.endLineNumber,endColumn:d.endColumn+1});const N=u.getValueInRange(d),R=u.getWordAtPosition({lineNumber:d.startLineNumber,column:d.startColumn},b);if(!R)return null;const E=u.getValueInRange(R);return S.BasicInplaceReplace.INSTANCE.navigateValueSet(d,N,R,E,s)})}loadForeignModule(l,d,s){const a=(b,N)=>this.c.fhr(b,N),u={host:(0,w.createProxyObject)(s,a),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(u,d),Promise.resolve((0,w.getAllMethodNames)(this.g))):new Promise((b,N)=>{U([l],R=>{this.g=R.create(u,d),b((0,w.getAllMethodNames)(this.g))},N)})}fmr(l,d){if(!this.g||typeof this.g[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this.g[l].apply(this.g,d))}catch(s){return Promise.reject(s)}}}n.EditorSimpleWorker=_,_.n=1e5,_.o=1e4;function g(L){return new _(L,null)}n.create=g,typeof importScripts=="function"&&(M.globals.monaco=(0,e.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map